
#speed goals
execute if score $var cart.status matches 1 run scoreboard players set @s cart.speed_goal 70
execute if entity @s[tag=speed.fast] run scoreboard players set @s cart.speed_goal 130
execute if score $var cart.status matches 0 run scoreboard players set @s cart.speed_goal 0
execute if entity @s[tag=speed.stop] run scoreboard players set @s cart.speed_goal 0
execute if entity @s[tag=speed.stop] run scoreboard players add @s cart.speed 2
execute if entity @s[tag=speed.slow] run scoreboard players set @s cart.speed_goal 30


execute if score @s cart.speed < @s cart.speed_goal run scoreboard players add @s cart.speed 1
execute if score @s cart.speed > @s cart.speed_goal run scoreboard players remove @s cart.speed 3


execute if score @s cart.speed matches ..-1 run scoreboard players set @s cart.speed 0



#apply motion
data modify storage effect cart_pos set from entity @s Pos
execute store result score @s x run data get storage effect cart_pos[0] 1000000
execute store result score @s z run data get storage effect cart_pos[2] 1000000

function effect:cart/get_direction

data modify storage effect cart_motion set from entity @s Motion
execute if entity @s[tag=dir.east] store result storage effect cart_motion[0] double 0.0015 run scoreboard players get @s cart.speed
execute if entity @s[tag=dir.west] store result storage effect cart_motion[0] double -0.0015 run scoreboard players get @s cart.speed
execute if entity @s[tag=dir.north] store result storage effect cart_motion[2] double -0.0015 run scoreboard players get @s cart.speed
execute if entity @s[tag=dir.south] store result storage effect cart_motion[2] double 0.0015 run scoreboard players get @s cart.speed

execute if score @s cart.speed matches 0 if entity @s[tag=dir.east] run data modify storage effect cart_motion[0] set value 0.00000000015d
execute if score @s cart.speed matches 0 if entity @s[tag=dir.west] run data modify storage effect cart_motion[0] set value -0.00000000015d
execute if score @s cart.speed matches 0 if entity @s[tag=dir.north] run data modify storage effect cart_motion[2] set value -0.00000000015d
execute if score @s cart.speed matches 0 if entity @s[tag=dir.south] run data modify storage effect cart_motion[2] set value 0.00000000015d

data modify entity @s Motion set from storage effect cart_motion
#
execute store result score @s calc.1 run data get storage effect cart_motion[0] 1000000
execute store result score @s calc.2 run data get storage effect cart_motion[2] 1000000
#
execute store result score @s prev.x run scoreboard players get @s x
execute store result score @s prev.z run scoreboard players get @s z
#

scoreboard players operation @s z += @s calc.2
scoreboard players operation @s x += @s calc.1

execute store result storage effect cart_pos[0] double 0.000001 run scoreboard players get @s x
execute store result storage effect cart_pos[2] double 0.000001 run scoreboard players get @s z
data modify entity @s Pos set from storage effect cart_pos






#braking particles
execute if score @s cart.prev.speed > @s cart.speed run particle minecraft:electric_spark ^0.45 ^ ^-0.55 0.015 0.025 0.015 0 1
execute if score @s cart.prev.speed > @s cart.speed run particle minecraft:electric_spark ^-0.2 ^ ^-0.55 0.015 0.025 0.015 0 1
execute if score @s cart.prev.speed > @s cart.speed run particle minecraft:electric_spark ^0.45 ^ ^0.55 0.015 0.025 0.015 0 1
execute if score @s cart.prev.speed > @s cart.speed run particle minecraft:electric_spark ^-0.2 ^ ^0.55 0.015 0.025 0.015 0 1
execute if score @s cart.prev.speed > @s cart.speed run playsound minecraft:entity.iron_golem.step block @a ~ ~ ~ 0.5 2
execute if score @s cart.prev.speed < @s cart.speed run particle minecraft:smoke ^0.55 ^ ^ 0.05 0.025 0.025 0.0025 1
scoreboard players operation @s cart.prev.speed = @s cart.speed


execute if score @s[tag=!cart.had_cube] cart.lifetime matches 10.. unless block ~ ~ ~ rail unless block ~ ~-0.5 ~ rail unless block ~ ~0.5 ~ rail if entity @e[tag=cube.main,tag=cube.metal_box,distance=..2] run scoreboard players set $var cart.until_metal_box 2
execute if score @s[tag=!cart.had_cube] cart.lifetime matches 10.. unless block ~ ~ ~ rail unless block ~ ~-0.5 ~ rail unless block ~ ~0.5 ~ rail if entity @e[tag=cube.main,tag=cube.metal_box,distance=..2] as @e[tag=cube.main,tag=cube.metal_box,distance=..2] run function cube:kill
execute if score @s[tag=!cart.had_cube] cart.lifetime matches 10.. unless block ~ ~ ~ rail unless block ~ ~-0.5 ~ rail unless block ~ ~0.5 ~ rail if entity @e[tag=cube.main,tag=cube.glass,distance=..2] as @e[tag=cube.main,tag=cube.glass,distance=..2] run function cube:kill
execute if score @s cart.lifetime matches 10.. unless block ~ ~ ~ rail unless block ~ ~-0.5 ~ rail unless block ~ ~0.5 ~ rail run kill @s
execute if block ~ ~ ~ rail[shape=ascending_west] run teleport @s ~ ~0.5 ~
execute if block ~ ~ ~ rail[shape=ascending_east] run teleport @s ~ ~0.5 ~
execute if block ~ ~ ~ rail[shape=ascending_north] run teleport @s ~ ~0.5 ~
execute if block ~ ~ ~ rail[shape=ascending_south] run teleport @s ~ ~0.5 ~
execute if score @s cart.speed matches 0 if score @s cart.lifetime matches 10.. unless block ~ ~ ~ rail[shape=north_south] unless block ~ ~ ~ rail[shape=east_west] run kill @e[tag=cart.passenger,limit=1,sort=nearest,distance=..0.2]
execute if score @s cart.speed matches 0 if score @s cart.lifetime matches 10.. unless block ~ ~ ~ rail[shape=north_south] unless block ~ ~ ~ rail[shape=east_west] run kill @s
