scoreboard players add @s beam.x 1
scoreboard players add @s beam.y 1
scoreboard players add @s beam.rx 1
scoreboard players add @s beam.ry 1
scoreboard players add @s converter.step 1
scoreboard players operation @s calc.4 = @s converter.step
scoreboard players add @s calc.4 720
scoreboard players remove @s calc.4 180


execute if score @s converter.step matches 1 run tag @s add converting
execute if score @s converter.step matches 1 run scoreboard players set $var beam.type 0
execute if score @s converter.step matches 1 as @e[tag=converter.item,limit=1,sort=nearest] run data modify entity @s item.tag.CustomModelData set value 100

execute if score @s converter.step matches 1..360 run function main:calc/cos {selector: "@s", angle: "calc.4", steps: 720, coef:500}
execute if score @s converter.step matches 1..360 as @e[tag=floater.lantern] store result score @s calc.3 run data get storage calc cos.value 1

scoreboard players operation @s calc.1 = @s converter.step
scoreboard players operation @s calc.1 %= 20 num
execute if score @s converter.step matches 0..260 if score @s calc.1 matches 0 run playsound minecraft:entity.evoker.prepare_summon block @a ~ ~ ~ 2 0

scoreboard players operation @s calc.1 = @s converter.step
scoreboard players operation @s calc.1 %= 2 num
execute if score @s converter.step matches 0..300 if score @s calc.1 matches 0 run playsound minecraft:block.beacon.ambient block @a ~ ~ ~ 0.5 2




execute if score @s converter.step matches 70 at @e[tag=floater.lantern,tag=floater.lantern.1] run playsound minecraft:entity.ravager.roar block @a ~ ~ ~ 1 0
execute if score @s converter.step matches 80 run tag @e[tag=floater.lantern,tag=floater.lantern.1] add floater.lantern.sending_beam
execute if score @s converter.step matches 118 run execute at @e[tag=floater.lantern,tag=floater.lantern.1] run playsound minecraft:entity.guardian.death block @a -16.50 5.20 68.5 2 0

execute if score @s converter.step matches 110 run execute at @e[tag=floater.lantern,tag=floater.lantern.4] run playsound minecraft:entity.ravager.roar block @a ~ ~ ~ 1.2 0.2
execute if score @s converter.step matches 120 run tag @e[tag=floater.lantern,tag=floater.lantern.4] add floater.lantern.sending_beam
execute if score @s converter.step matches 158 run execute at @e[tag=floater.lantern,tag=floater.lantern.4] run playsound minecraft:entity.guardian.death block @a -16.50 5.20 68.5 2 0

execute if score @s converter.step matches 150 run execute at @e[tag=floater.lantern,tag=floater.lantern.3] run playsound minecraft:entity.ravager.roar block @a ~ ~ ~ 1.4 0.4
execute if score @s converter.step matches 160 run tag @e[tag=floater.lantern,tag=floater.lantern.3] add floater.lantern.sending_beam
execute if score @s converter.step matches 198 run execute at @e[tag=floater.lantern,tag=floater.lantern.3] run playsound minecraft:entity.guardian.death block @a -16.50 5.20 68.5 2 0

execute if score @s converter.step matches 180 run execute at @e[tag=floater.lantern,tag=floater.lantern.5] run playsound minecraft:entity.ravager.roar block @a ~ ~ ~ 1.6 0.6
execute if score @s converter.step matches 190 run tag @e[tag=floater.lantern,tag=floater.lantern.5] add floater.lantern.sending_beam
execute if score @s converter.step matches 228 run execute at @e[tag=floater.lantern,tag=floater.lantern.5] run playsound minecraft:entity.guardian.death block @a -16.50 5.20 68.5 2 0

execute if score @s converter.step matches 190 run execute at @e[tag=floater.lantern,tag=floater.lantern.2] run playsound minecraft:entity.ravager.roar block @a ~ ~ ~ 1.8 0.8
execute if score @s converter.step matches 200 run tag @e[tag=floater.lantern,tag=floater.lantern.2] add floater.lantern.sending_beam
execute if score @s converter.step matches 238 run execute at @e[tag=floater.lantern,tag=floater.lantern.2] run playsound minecraft:entity.guardian.death block @a -16.50 5.20 68.5 2 0

execute if score @s converter.step matches 210 run execute at @e[tag=floater.lantern,tag=floater.lantern.2] run playsound minecraft:entity.ravager.roar block @a ~ ~ ~ 1.85 0.6
execute if score @s converter.step matches 225 run execute at @e[tag=floater.lantern,tag=floater.lantern.3] run playsound minecraft:entity.ravager.roar block @a ~ ~ ~ 1.9 0.7
execute if score @s converter.step matches 230 run execute at @e[tag=floater.lantern,tag=floater.lantern.5] run playsound minecraft:entity.ravager.roar block @a ~ ~ ~ 1.95 0.8
execute if score @s converter.step matches 250 run execute at @e[tag=floater.lantern,tag=floater.lantern.1] run playsound minecraft:entity.ravager.roar block @a ~ ~ ~ 2 0.9


execute if score @s converter.step matches ..260 run particle dust 0.176 0.58 0.769 0.5 ~ ~1 ~ 0.2 0.1 0.2 1 2
execute if score @s converter.step matches 260..345 run particle dust 0.169 0.914 0.145 0.35 ~ ~1 ~ 0.3 0.1 0.3 1 2
execute if score @s converter.step matches 345.. run particle dust 0.169 0.914 0.145 0.1 ~ ~1 ~ 0.15 0.1 0.15 1 1


execute if score @s converter.step matches 260 run summon marker ~ ~45 ~ {Tags:["temp","transformation_line"]}
execute if score @s converter.step matches 260 run function effect:transformation_line
execute if score @s converter.step matches 260 run kill @e[tag=temp]
execute if score @s converter.step matches 260 run playsound minecraft:entity.wither.death block @a ~ ~ ~ 1 0
execute if score @s converter.step matches 260 run playsound minecraft:entity.lightning_bolt.impact block @a ~ ~ ~ 1 1
execute if score @s converter.step matches 260 run playsound minecraft:entity.lightning_bolt.thunder block @a ~ ~ ~ 1 1
execute if score @s converter.step matches 260 run particle minecraft:egg_crack ~ ~ ~ 0.5 0.5 0.5 1 50
execute if score @s converter.step matches 260 run particle minecraft:sculk_soul ~ ~ ~ 0.2 0.2 0.2 0.5 50
execute if score @s converter.step matches 260 run summon minecraft:lightning_bolt ~ 400 ~
execute if score @s converter.step matches 260 run tag @s remove converting
execute if score @s converter.step matches 260 as @e[tag=converter.item,limit=1,sort=nearest] run data modify entity @s item.tag.CustomModelData set value 701


execute as @e[tag=floater.lantern,tag=floater.lantern.sending_beam] at @s if score @e[tag=floater.converter,limit=1] converter.step matches 260.. run scoreboard players remove @s beam.limit 2
execute as @e[tag=floater.lantern,tag=floater.lantern.sending_beam] at @s unless score @s beam.limit matches 41.. run scoreboard players add @s beam.limit 1
execute as @e[tag=floater.lantern,tag=floater.lantern.sending_beam] at @s positioned ~ ~2 ~ run summon marker ~ ~ ~ {Tags:["temp_beam","cast.beam"]}
execute as @e[tag=temp_beam] at @s run teleport @s ~ ~ ~ facing entity @e[tag=floater.converter,limit=1]
execute as @e[tag=temp_beam] at @s run teleport @s ~ ~ ~ ~ ~2
execute as @e[tag=temp_beam] at @s run particle dust 0.169 0.914 0.145 1 ~ ~1.2 ~ 0.2 0.25 0.2 0 2
execute as @e[tag=temp_beam] at @s run scoreboard players operation @s beam.limit = @e[tag=floater.lantern,sort=nearest,limit=1] beam.limit
execute as @e[tag=temp_beam] at @s if score @s beam.limit matches 2 run particle flash ~ ~0.5 ~ 0 0 0 0 1 force
execute as @e[tag=temp_beam] at @s if score @s beam.limit matches 2 run playsound minecraft:entity.evoker.cast_spell block @a ~ ~ ~ 1 2
execute as @e[tag=temp_beam] at @s run scoreboard players operation @s beam.x = @e[tag=floater.converter,limit=1] beam.x
execute as @e[tag=temp_beam] at @s run scoreboard players operation @s beam.y = @e[tag=floater.converter,limit=1] beam.y
execute as @e[tag=temp_beam] at @s run scoreboard players operation @s beam.rx = @e[tag=floater.converter,limit=1] beam.rx
execute as @e[tag=temp_beam] at @s run scoreboard players operation @s beam.ry = @e[tag=floater.converter,limit=1] beam.ry
execute as @e[tag=temp_beam] at @s run function item:weapon/beam/create




execute if score @s converter.step matches 360 run scoreboard players set @e[tag=floater.lantern,tag=floater.lantern.sending_beam] beam.limit -3
execute if score @s converter.step matches 360 run tag @e remove floater.lantern.sending_beam
execute if score @s converter.step matches 360 run scoreboard players set $var beam.type 1
execute if score @s converter.step matches 360 run scoreboard players set @s converter.step -1

kill @e[tag=temp_beam]
