

scoreboard players add @s effect.lantern.script 1
execute if score @s effect.lantern.script matches 10.. unless entity @e[tag=lantern_target] run execute as @e[tag=button.main,limit=1,sort=nearest] at @s run scoreboard players set @s button.can_use 1
execute if score @s effect.lantern.script matches 10.. unless entity @e[tag=lantern_target] run execute as @e[tag=button.main,limit=1,sort=nearest] at @s run function button:press
execute if score @s effect.lantern.script matches 10.. unless entity @e[tag=lantern_target] run scoreboard players set @s beam.limit -5
execute if score @s effect.lantern.script matches 10.. unless entity @e[tag=lantern_target] run scoreboard players set @s effect.lantern.script -1

execute if score @s effect.lantern.script matches 1 run tag @e remove lantern_target
execute if score @s effect.lantern.script matches 1 run tag @e[tag=playing,scores={player.in_observatory=1},tag=!alternator_given,limit=1,sort=nearest] add lantern_target
execute if score @s effect.lantern.script matches 1.. run particle minecraft:egg_crack -13.5 6.3 -21.5 0.1 0.15 0.1 0 2

execute if score @s effect.lantern.script matches 10.. as @e[tag=lantern_target] at @s run effect give @s slowness 1 1
execute if score @s effect.lantern.script matches 10.. as @e[tag=lantern_target] at @s run effect give @s slow_falling 1
execute if score @s effect.lantern.script matches 10.. as @e[tag=lantern_target] at @s run particle egg_crack ~ ~ ~ 0.2 0.75 0.25 0 3
execute if score @s effect.lantern.script matches 10 run playsound minecraft:block.fire.extinguish block @a ~ ~ ~ 0.25 0
execute if score @s effect.lantern.script matches 10..40 run scoreboard players add @s beam.limit 1
execute if score @s effect.lantern.script matches 10 run scoreboard players set $var beam.type 0
execute if score @s effect.lantern.script matches 10.. positioned ~ ~-0.25 ~ run teleport @s ~ ~0.25 ~ facing entity @e[tag=lantern_target,limit=1] feet
execute if score @s effect.lantern.script matches 10.. positioned ~ ~-1.4 ~ run function item:weapon/beam/create

execute if score @s effect.lantern.script matches 20 as @e[tag=lantern_target] at @s run playsound minecraft:entity.evoker.prepare_summon block @a ~ ~ ~ 2 0
execute if score @s effect.lantern.script matches 40 as @e[tag=lantern_target] at @s run playsound minecraft:entity.evoker.prepare_summon block @a ~ ~ ~ 2.5 0.15
execute if score @s effect.lantern.script matches 60 as @e[tag=lantern_target] at @s run playsound minecraft:entity.evoker.prepare_summon block @a ~ ~ ~ 3 0.3
execute if score @s effect.lantern.script matches 80 as @e[tag=lantern_target] at @s run playsound minecraft:entity.evoker.prepare_summon block @a ~ ~ ~ 3.5 0.6
execute if score @s effect.lantern.script matches 100 as @e[tag=lantern_target] at @s run playsound minecraft:entity.evoker.prepare_summon block @a ~ ~ ~ 4.0 0.8
execute if score @s effect.lantern.script matches 85 as @e[tag=lantern_target] at @s run playsound minecraft:entity.ravager.roar block @a ~ ~ ~ 1 0

execute if score @s effect.lantern.script matches 105 as @e[tag=lantern_target] at @s run playsound minecraft:entity.skeleton.converted_to_stray block @a ~ ~ ~ 2 0
execute if score @s effect.lantern.script matches 105 as @e[tag=lantern_target] at @s run playsound minecraft:entity.wither.death block @a ~ ~ ~ 1 0
execute if score @s effect.lantern.script matches 105 as @e[tag=lantern_target] at @s run playsound minecraft:entity.lightning_bolt.impact block @a ~ ~ ~ 1 1
execute if score @s effect.lantern.script matches 105 as @e[tag=lantern_target] at @s run playsound minecraft:entity.lightning_bolt.thunder block @a ~ ~ ~ 1 1
execute if score @s effect.lantern.script matches 105 as @e[tag=lantern_target] at @s run summon lightning_bolt ~ ~15 ~
execute if score @s effect.lantern.script matches 105 as @e[tag=lantern_target] at @s run effect give @s[distance=..5] resistance 3 5
execute if score @s effect.lantern.script matches 105 as @e[tag=lantern_target] at @s run effect give @s[distance=..5] luck 15 10
execute if score @s effect.lantern.script matches 105 as @e[tag=lantern_target] at @s run tag @s add alternator_given
execute if score @s effect.lantern.script matches 105 as @e[tag=lantern_target] at @s run tag @s add transformation_line
execute if score @s effect.lantern.script matches 105 positioned ~ ~-0.5 ~ run function effect:transformation_line
execute if score @s effect.lantern.script matches 105 as @e[tag=lantern_target] at @s run tellraw @s [{"text":"\uE001\n"},{"text":"  你的传送器充满了能量\n\n","bold":true,"color":"#2ACF3A"},{"text":"现在这个设备可以将你传送到其他维度!\n\n","bold":false,"color":"#1bbb32"},{"text":"M ","color":"red","bold":true,"obfuscated":true},{"text":"你在每个场景的位置都是一样的,只是你周围的环境在变化！\n如果你想要到达新的或者难以到达的地方,试试使用交流器。\n","bold":false,"color":"red"},{"text":"\uE001","color":"white"}]
execute if score @s effect.lantern.script matches 105 as @e[tag=lantern_target] at @s run scoreboard players set @s player.notify_leaving_observatory 1
execute if score @s effect.lantern.script matches 105 run scoreboard players set $var beam.type 1
execute if score @s effect.lantern.script matches 105 as @e[tag=lantern_target] at @s run advancement grant @s only lh:progress/alternator
execute if score @s effect.lantern.script matches 105 as @e[tag=lantern_target] at @s run scoreboard players set @s music.mood 3
execute if score @s effect.lantern.script matches 105 as @e[tag=lantern_target] at @s run function player:music/new
execute if score @s effect.lantern.script matches 105 if score $var stats.at_checkpoint matches ..3 run scoreboard players set $var stats.at_checkpoint 4
execute if score @s effect.lantern.script matches 105 run execute positioned -14.52 5.36 -14.00 run scoreboard players set @e[tag=button.main,limit=1,sort=nearest] button.can_use 1
execute if score @s effect.lantern.script matches 105 run execute positioned -14.52 5.36 -14.00 as @e[tag=button.main,limit=1,sort=nearest] at @s run function button:press
execute if score @s effect.lantern.script matches 105 run scoreboard players set @s effect.lantern.script -1

