
scoreboard players add $var time.played 1
execute if score $var stats.at_checkpoint matches 1 run scoreboard players add $var time.alpha 1
execute if score $var stats.at_checkpoint matches 2 run scoreboard players add $var time.beta 1
execute if score $var stats.at_checkpoint matches 3 run scoreboard players add $var time.gamma 1
execute if score $var stats.at_checkpoint matches 4 run scoreboard players add $var time.alternator 1
execute if score $var stats.at_checkpoint matches 5 run scoreboard players add $var time.epsilon 1



execute positioned -13.56 4.50 -21.59 run particle minecraft:egg_crack ~ ~5.5 ~ 2.5 1 2.5 1 1
execute positioned -13.56 4.50 -21.59 run particle minecraft:white_ash ~ ~5 ~ 5 2 3 1 2

execute positioned 44.56 79.00 1087.68 run particle minecraft:egg_crack ~ ~ ~ 1.5 1 1.5 1 1
particle minecraft:dust 0.318 0.812 0.165 1 44.5 77.16 1088.5 0.1 0.1 0.1 1 1

particle minecraft:bubble_column_up -22.5 3.50 -35.5 0.2 0.1 0.2 0.7 1
particle minecraft:bubble_column_up -22.5 3.50 -36.5 0.2 0.1 0.2 0.7 1
particle minecraft:bubble_column_up -21.5 3.50 -35.5 0.2 0.1 0.2 0.7 1
particle minecraft:bubble_column_up -21.5 3.50 -36.5 0.2 0.1 0.2 0.7 1

execute if score $var bookshelf.complete matches 1 if score $var bookshelf.script matches 0.. run function lh:event/bookshelf_complete

execute if block -27 5 -22 lever[powered=true] positioned -26.34 5.75 -21.37 run function door:open
execute if block -27 5 -22 lever[powered=false] positioned -26.34 5.75 -21.37 run function door:close

execute if block -5 5 12 lever[powered=true] positioned -2.54 4.00 13.54 run function door:open
execute if block -5 5 12 lever[powered=false] positioned -2.54 4.00 13.54 run function door:close

execute if block 2 5 5 lever[powered=true] positioned 2 5 5 run function door:open
execute if block 2 5 5 lever[powered=false] positioned 2 5 5 run function door:close


execute if block 39 4 -39 lever[powered=true] positioned 36.69 4.00 -38.59 run function door:open
execute if block 39 4 -39 lever[powered=false] positioned 36.69 4.00 -38.59 run function door:close
execute if block 39 4 -39 lever[powered=true] positioned 39.35 4.00 -35.71 run function door:close
execute if block 39 4 -39 lever[powered=false] positioned 39.35 4.00 -35.71 run function door:open

execute as @e[tag=lever] at @s if block ~ ~ ~ lever[facing=west] run setblock ~ ~ ~ lever[facing=north,face=floor]
execute as @e[tag=lever] at @s if block ~ ~ ~ lever[facing=east] run setblock ~ ~ ~ lever[facing=south,face=floor]
execute as @e[tag=lever] at @s if block ~ ~ ~ lever positioned ~-0.5 ~ ~-0.5 if entity @e[tag=lever.display,distance=..0.2] run playsound minecraft:item.armor.equip_iron block @a ~ ~ ~ 1
execute as @e[tag=lever] at @s if block ~ ~ ~ lever positioned ~-0.5 ~ ~-0.5 if entity @e[tag=lever.display,distance=..0.2] run kill @s

execute if block 25 4 -17 lever[powered=true] positioned 25 4 -15 run function door:open
execute if block 24 4 -18 lever[powered=true] positioned 22 4 -18 run function door:open
execute if block 25 4 -19 lever[powered=true] positioned 25 4 -21 run function door:open

execute if block 25 4 -17 lever[powered=false] positioned 25 4 -15 run function door:close
execute if block 24 4 -18 lever[powered=false] positioned 22 4 -18 run function door:close
execute if block 25 4 -19 lever[powered=false] positioned 25 4 -21 run function door:close

execute positioned 39.79 4.00 4.27 if score @e[tag=plate.main,distance=..5,limit=1] plate.pressed matches 1 run function door:open
execute positioned 39.79 4.00 4.27 if score @e[tag=plate.main,distance=..5,limit=1] plate.pressed matches 1 positioned 29.94 4.00 -3.68 run function door:open
execute positioned 19.57 4.00 -17.97 if score @e[tag=plate.main,distance=..5,limit=1] plate.pressed matches 1 positioned 18.79 4.00 -14.84 run function door:open
execute positioned 19.57 4.00 -17.97 if score @e[tag=plate.main,distance=..5,limit=1] plate.pressed matches 0 positioned 18.79 4.00 -14.84 run function door:close

execute positioned -2.50 4.00 -25.37 if score @e[tag=plate.main,distance=..5,limit=1] plate.pressed matches 1 if score $var event.armor_plate_pressed matches 0 run tellraw @a {"text":"\n破坏所有盔甲架以打开一个密室...\n","color":"gray"}
execute positioned -2.50 4.00 -25.37 if score @e[tag=plate.main,distance=..5,limit=1] plate.pressed matches 1 if score $var event.armor_plate_pressed matches 0 run scoreboard players set $var quest.armor 1
execute positioned -2.50 4.00 -25.37 if score @e[tag=plate.main,distance=..5,limit=1] plate.pressed matches 1 if score $var event.armor_plate_pressed matches 0 run scoreboard players set $var event.armor_plate_pressed 1

execute positioned 3.5 4.025 -31.5 run particle dust 1 1 1 0.5 ~ ~ ~ 0.2 0 0.2 1 1
execute positioned -2.5 4.025 -31.5 run particle dust 1 1 1 0.5 ~ ~ ~ 0.2 0 0.2 1 1

execute as @e[tag=removable_lever] at @s run scoreboard players add @s calc.6 1
execute as @e[tag=removable_lever] at @s if score @s calc.6 matches 20 run scoreboard players set @s calc.6 0
execute as @e[tag=removable_lever] at @s if score @s calc.6 matches 0 run setblock ~ ~2 ~ redstone_block
execute as @e[tag=removable_lever] at @s if score @s calc.6 matches 10 run setblock ~ ~2 ~ air
execute as @e[tag=removable_lever] at @s if block ~ ~ ~ lever[powered=true] run function lh:event/lever_removed
execute positioned 29.51 5.00 -20.54 run scoreboard players set @e[tag=cube.main,tag=cube.tnt,distance=..1] primed 25
execute positioned 29.51 5.00 -20.54 run scoreboard players set @e[tag=cube.main,tag=cube.tnt,distance=..1] cube.on_fire 1

execute positioned 4.40 4.00 18.81 if score @e[tag=plate.main,distance=..5,limit=1] plate.pressed matches 0 run function door:close
execute positioned 4.40 4.00 18.81 if score @e[tag=plate.main,distance=..5,limit=1] plate.pressed matches 1 run function door:open

execute if score $var cinematic.transition matches -1 if score $var cinematic.status matches 0 if score $var button.total matches 2 positioned -2.16 4.00 -17.35 run function door:open
execute if score $var cinematic.transition matches -1 if score $var cinematic.status matches 0 if score $var button.total matches ..1 positioned -2.16 4.00 -17.35 run function door:close


execute if score $var water.sound matches 2 positioned 39.37 8.00 -1.55 run playsound minecraft:weather.rain.above ambient @a[distance=..10] 39.37 8.00 -1.55 0.08 1
execute if score $var water.sound matches 1 run playsound minecraft:item.trident.riptide_1 ambient @a 39.37 8.00 -1.55 0.1 0.6
execute if score $var water.sound matches 2 run particle falling_water 39.5 8.00 -1.5 0.1 0 0.1 0 2
execute if score $var water.sound matches 2 run particle falling_water 25.5 9.00 3.5 0.1 0 0.1 0 2
execute if score $var water.sound matches 2 run particle falling_water 25.5 9.00 10.5 0.1 0 0.1 0 2

execute unless score $var event.redstone_broke matches 1 positioned 32.38 4.06 -3.45 unless block ~ ~ ~ redstone_wire positioned 32.45 4.00 -0.66 run function door:open
execute unless score $var event.redstone_broke matches 1 positioned 32.38 4.06 -3.45 unless block ~ ~ ~ redstone_wire run playsound minecraft:misc.flip_lever block @a ~ ~ ~ 0.5
execute unless score $var event.redstone_broke matches 1 positioned 32.38 4.06 -3.45 unless block ~ ~ ~ redstone_wire run scoreboard players set $var event.redstone_broke 1

execute if block 11 5 -3 lever[powered=true] positioned 11.63 4.00 -7.19 run function door:open
execute if block 11 5 -3 lever[powered=true] positioned 15.20 4.00 -3.55 run function door:open
execute if block 11 5 -3 lever[powered=true] positioned 11.31 4.00 -0.02 run function door:open

execute if block 11 5 -3 lever[powered=false] positioned 11.63 4.00 -7.19 run function door:close
execute if block 11 5 -3 lever[powered=false] positioned 15.20 4.00 -3.55 run function door:close
execute if block 11 5 -3 lever[powered=false] positioned 11.31 4.00 -0.02 run function door:close

execute if score $var event.eye_entered matches 0 if score $var time.played matches 1000.. run playsound minecraft:particle.soul_escape block @a 50.50 4.8 -9.50 0.65 0.8
execute if score $var event.eye_entered matches 1 run playsound minecraft:particle.soul_escape block @a 50.50 4.8 -9.50 0.8 0.4
execute if score $var event.eye_entered matches 1 unless score $var cinematic.id matches 10 positioned 50.50 4.81 -9.5 run particle smoke ~ ~0.3 ~ 0.1 0.1 0.1 0 1

execute as @e[type=armor_stand,tag=armor] at @s positioned ~ -7 ~ if entity @s[distance=..2] run scoreboard players add $var armor.destroyed 1
execute as @e[type=armor_stand,tag=armor] at @s positioned ~ -7 ~ if entity @s[distance=..2] run kill @s
execute as @e[type=item] at @s positioned ~ -20 ~ if entity @s[distance=..10] unless entity @s[nbt={Item:{tag:{id:200}}}] run teleport @s @p

execute if score $var removed_lever.1 matches 1 run particle minecraft:electric_spark 25.5 6.5 -1.5 0.2 2 0.2 0.2 1
execute if score $var removed_lever.1 matches 1 run particle minecraft:electric_spark 19.5 8.5 3.5 0.2 0.2 2 0.2 1

execute if score $var removed_lever.2 matches 1 run particle minecraft:electric_spark 11.5 8.5 -3.5 0.2 0.2 2 0.2 1
execute if score $var removed_lever.2 matches 1 run particle minecraft:electric_spark 18.5 8.5 3.5 0.2 0.2 2 0.2 1

execute if score $var removed_lever.3 matches 1 run particle minecraft:electric_spark 25 8.5 -10.5 2 0.2 0.2 0.2 1
execute if score $var removed_lever.3 matches 1 run particle minecraft:electric_spark 17.5 8.5 0.5 0.2 0.2 4 0.2 2
execute store result bossbar eye value run scoreboard players get $var eye.health


execute as @e[type=arrow,nbt={inGround:0b},tag=!arrow_passed] at @s if entity @e[tag=eye.main,distance=..3.75] run function lh:event/arrow_deflected

execute as @a at @s positioned ~ 0.15 ~ if entity @s[distance=..3.3] run particle dust 1 0.224 0.224 0.8 ~ 0 ~ 1 0 1 0 5 normal @s
execute positioned -7.5 3.06 -21.5 as @a[tag=playing,distance=..0.75] at @s run damage @s 5 arrow
execute positioned 52.5 42.06 1011.5 as @a[tag=playing,distance=..0.75] at @s run damage @s 5 arrow



execute if score $var eye_in_portal matches 0.. run function lh:event/transition_to_end
execute as @e[tag=in_temple] at @s run particle witch ~ ~0.2 ~ 0.3 0.3 0.3 0.02 1 
tag @e remove in_temple


