
execute as @a[tag=entered] unless score @s game.tick = $var game.tick run function player:music/update_mood
execute as @a[tag=entered] unless score @s game.tick = $var game.tick run scoreboard players set @s music.duration 350
execute as @a[tag=entered] unless score @s game.tick = $var game.tick run tag @s add give_items_soon
scoreboard players add $var game.tick 1
scoreboard players operation @a game.tick = $var game.tick
execute if entity @a if entity @a[tag=!entered] run function lh:setup/forceloads
execute if entity @a as @a[tag=!entered] at @s if loaded 92 79 -1007 if entity @e[tag=start_lobby_load] run function player:entered

scoreboard players operation $var prev.online = $var online
execute store result score $var online run execute if entity @a
execute store result score $var playing run execute if entity @e[tag=playing]
execute unless score $var prev.online = $var online run function main:multi/on_player_count_change

kill @e[tag=tick_clear]
tag @e[tag=tick_clear_next] add tick_clear




#increment counter
scoreboard players add $var map.step 1
execute if score $var map.step matches 4.. run scoreboard players set $var map.step 0

#all entity loops
execute if entity @a if score $var game.stage matches 0 run function lh:start/loop
execute if entity @a if score $var game.stage matches 1 unless score $var cinematic.id matches 0 run function lh:loop
execute if entity @a if score $var game.stage matches 2 run function lh:end/loop
execute if entity @a if score $var game.stage matches 1.. as @a at @s unless score @s id matches 1.. run function main:multi/get_id
execute if entity @a run function main:interact/loop


execute as @a at @s run function player:loop
execute as @a at @s run function item:loop with storage tool display
execute run function map:new/loop


execute if entity @a as @e[type=armor_stand,tag=small_chest] at @s if entity @a[tag=playing,distance=..15] run function chest:loop
execute if entity @a as @e[type=item_display,tag=button.main,tag=!button.display_tube_status,tag=!button.chute_unlock] at @s if entity @a[tag=playing,distance=..10] run function button:loop
execute if entity @a as @e[type=item_display,tag=button.main,tag=button.display_tube_status] at @s if entity @a[tag=playing,distance=..20] run function button:loop
execute if entity @a as @e[type=item_display,tag=button.main,tag=button.chute_unlock] at @s if entity @a[tag=playing,distance=..70] run function button:loop
execute if score $var event.eye_entered matches 0 if entity @a as @e[type=item_display,tag=eye.main] at @s run function eye:loop
execute if entity @a as @e[type=pig,tag=cube.main] at @s if entity @e[tag=cube.hitbox,distance=..5] run scoreboard players set @s cube.time.ungrabbed 4
execute if entity @a as @e[type=pig,tag=cube.main,tag=!cube.obsidian,tag=!cube.lodestone,tag=!cube.non_solid] if score @s cube.time.ungrabbed matches ..100 at @s run function cube:loop
execute if entity @a as @e[type=pig,tag=cube.main,tag=cube.non_solid] at @s run function cube:loop
execute if entity @a as @e[type=pig,tag=cube.main,tag=!cube.obsidian,tag=!cube.lodestone,tag=!cube.non_solid] unless score @s cube.time.ungrabbed matches ..100 if entity @s[tag=cube.in_temple] run tag @s add in_temple
execute if entity @a as @e[type=pig,tag=cube.obsidian] at @s run function cube:loop
execute if entity @a as @e[type=pig,tag=cube.tube_quartz] at @s run function cube:loop
execute if entity @a as @e[type=pig,tag=cube.lodestone] at @s run function cube:loop
execute if entity @a as @e[type=interaction,tag=plate.main] at @s if score $var game.stage matches 0 if entity @a[tag=playing,distance=..10] run function plate:loop
execute if entity @a as @e[type=interaction,tag=plate.main] at @s if score $var game.stage matches 1 run function plate:loop
execute if entity @a as @e[type=armor_stand,tag=door] at @s run function door:loop

execute if entity @a run function effect:loop

execute if entity @a run function cinematic:loop








execute as @e[type=item,tag=!item_nbt_checked] at @s if data entity @s Item.tag.teleport_to_friend positioned ~ ~-1.5 ~ as @p run function player:inv/teleport_to_friend
execute as @e[type=item,tag=!item_nbt_checked] at @s if data entity @s Item.tag.remove_if_disappear run kill @s
execute as @e[type=item,tag=!item_nbt_checked] at @s run data modify entity @s Invulnerable set value 1b
tag @e[type=item] add item_nbt_checked
scoreboard players add @e[type=item,nbt={Item:{id:"minecraft:stick"}}] calc.6 1
scoreboard players add @e[type=item,nbt={Item:{id:"minecraft:writable_book"}}] calc.6 1
execute as @e[type=item] if score @s calc.6 matches 15.. run kill @s



execute if score $var debug.bars matches 1 run title @a actionbar "\uE021"
execute if score $var debug.bars matches 1 run scoreboard players set @a actionbar.priority 400
execute if score $var debug.bars matches 1 run scoreboard players set @a actionbar 2
execute if score $var debug.bars matches 1 run bossbar set cinematic name "\uE020"


