scoreboard players set @s button.cooldown 4

execute if score @s button.type matches 0 unless score @s button.can_use matches 0 if score @s button.status matches 0 run playsound misc.click block @a ~ ~ ~ 0.25
execute if score @s button.type matches 0 unless score @s button.can_use matches 0 if score @s button.status matches 0 run function animated_java:button/animations/quick_press/play

execute if score @s button.type matches 1 unless score @s button.can_use matches 0 if score @s button.status matches 0 run playsound block.grindstone.use block @a ~ ~ ~ 1 0
execute if score @s button.type matches 1 unless score @s button.can_use matches 0 if score @s button.status matches 0 run playsound minecraft:block.piston.contract block @a ~ ~ ~ 1 0
execute if score @s button.type matches 1 unless score @s button.can_use matches 0 if score @s button.status matches 0 run function animated_java:button/animations/long_press/play

execute if score @s button.type matches 2 unless score @s button.can_use matches 0 run playsound misc.flip_lever block @a ~ ~ ~ 0.25 0.5
execute if score @s[tag=!button.start_puzzle] button.type matches 2 unless score @s button.can_use matches 0 if score @s[tag=!button.lab_toggle_map] button.status matches 0 run playsound block.grindstone.use block @a ~ ~ ~ 1 0
execute if score @s button.type matches 2 unless score @s button.can_use matches 0 if score @s button.status matches 0 run function animated_java:button/animations/turn_in/play
execute if score @s button.type matches 2 unless score @s button.can_use matches 0 if score @s button.status matches 1 run function animated_java:button/animations/turn_out/play

execute if score @s button.type matches 3 unless score @s button.can_use matches 0 if score @s button.status matches 0 run playsound misc.click block @a ~ ~ ~ 0.25 0.8
execute if score @s button.type matches 3 unless score @s button.can_use matches 0 if score @s button.status matches 0 run function animated_java:button/animations/hold_in/play
execute if score @s[tag=!button.gun_x,tag=!button.gun_y] button.type matches 3 unless score @s button.can_use matches 0 if score @s button.status matches 1 run playsound misc.click block @a ~ ~ ~ 0.15 0.5
execute if score @s[tag=!button.gun_x,tag=!button.gun_y] button.type matches 3 unless score @s button.can_use matches 0 if score @s button.status matches 1 run function animated_java:button/animations/hold_out/play

execute if score @s button.can_use matches 0 unless score @s button.type matches 1 run playsound block.stone.break block @a ~ ~ ~ 1 0




execute if entity @s[tag=button.wooden] if score @s button.status matches 0 run scoreboard players set $var cart.status 1
execute if entity @s[tag=button.wooden] if score @s button.status matches 0 if score $var game.stage matches 2 if score $var event.end_player_near_hideout matches 0 run tellraw @a {"text":"\n跟随矿车...\n","color":"dark_gray"}
execute if entity @s[tag=button.chute_unlock] unless score @s button.can_use matches 0 if score @s button.status matches 0 if score $var tube.phase matches 0 run tellraw @a {"text":"\n一个运输管正在等待空心树中等待批准...\n","color":"gray"}
execute if entity @s[tag=button.chute_unlock] unless score @s button.can_use matches 0 if score @s button.status matches 0 if score $var tube.phase matches 1 run tellraw @a {"text":"\n下一个运输管正在矮人矿井中等待批准...\n","color":"gray"}
execute if entity @s[tag=button.chute_unlock] unless score @s button.can_use matches 0 if score @s button.status matches 0 if score $var tube.phase matches 2 run tellraw @a {"text":"\n又有一个运输管在旧仓库中启动了...\n","color":"gray"}
execute if entity @s[tag=button.chute_unlock] unless score @s button.can_use matches 0 if score @s button.status matches 0 if score $var tube.phase matches 3 run tellraw @a {"text":"\n最后一个运输管在实验室中启动了...\n","color":"gray"}
execute if entity @s[tag=button.chute_unlock] unless score @s button.can_use matches 0 if score @s button.status matches 0 run scoreboard players add $var tube.phase 1
execute if entity @s[tag=button.chute_unlock] unless score @s button.can_use matches 0 if score @s button.status matches 0 run scoreboard players set @s button.chute_status 2
execute if entity @s[tag=button.beamer_toggle] if score @s button.status matches 0 run scoreboard players set @e[tag=beamer,limit=1,sort=nearest] beamer.status 1
execute if entity @s[tag=button.cart_system_halt] if score @s button.status matches 0 run scoreboard players set $var cart.halt 0
execute if entity @s[tag=button.cart_system_halt] if score @s button.status matches 1 run scoreboard players set $var cart.halt 1
execute if entity @s[tag=button.teleport_back_to_maze] if score @s button.status matches 0 as @a[tag=playing,limit=1,sort=nearest] at @s run function player:action/teleport_back_to_maze
execute if entity @s[tag=button.trash_chute_door] if score @s button.status matches 0 run function door:open
execute if entity @s[tag=button.trash_chute_door] if score @s button.status matches 1 run function door:close
execute if entity @s[tag=button.cart_request_glass] if score @s button.status matches 0 positioned 57.5 105.5 985.5 unless entity @e[tag=cart.has_cube,distance=..10] unless entity @e[tag=cart.had_cube,distance=..10] unless entity @e[tag=cube.glass,distance=..15] if score $var cart.status matches 0 run scoreboard players set @p actionbar.priority 300
execute if entity @s[tag=button.cart_request_glass] if score @s button.status matches 0 positioned 57.5 105.5 985.5 unless entity @e[tag=cart.has_cube,distance=..10] unless entity @e[tag=cart.had_cube,distance=..10] unless entity @e[tag=cube.glass,distance=..15] if score $var cart.status matches 0 run scoreboard players set @p actionbar 60
execute if entity @s[tag=button.cart_request_glass] if score @s button.status matches 0 positioned 57.5 105.5 985.5 unless entity @e[tag=cart.has_cube,distance=..10] unless entity @e[tag=cart.had_cube,distance=..10] unless entity @e[tag=cube.glass,distance=..15] if score $var cart.status matches 0 run title @p actionbar {"text":"矿车系统尚未激活... 尝试在圣所的底层寻找开关。","color":"red"}
execute if entity @s[tag=button.cart_request_glass] if score @s button.status matches 0 positioned 57.5 105.5 985.5 unless entity @e[tag=cart.has_cube,distance=..10] unless entity @e[tag=cart.had_cube,distance=..10] unless entity @e[tag=cube.glass,distance=..15] if score $var cart.status matches 1 run playsound minecraft:block.piston.contract block @a ~ ~ ~ 0.5
execute if entity @s[tag=button.cart_request_glass] if score @s button.status matches 0 positioned 57.5 105.5 985.5 unless entity @e[tag=cart.has_cube,distance=..10] unless entity @e[tag=cart.had_cube,distance=..10] unless entity @e[tag=cube.glass,distance=..15] if score $var cart.status matches 1 run function effect:cart/summon/has_glass_cube
execute if entity @s[tag=button.dropper_request_tnt] if score @s button.status matches 0 positioned 49.52 43.00 998.41 unless entity @e[tag=cube.tnt_layer_4] positioned 34.55 47 998.9 run function cube:summon/tnt_layer_4
execute if entity @s[tag=button.request_cube_from_tube] if score @s button.status matches 0 if score $var tube.phase matches -1 run tellraw @a {"text":"\n运输管系统在圣所顶层的隐藏房间中启动了...\n","color":"gray"}
execute if entity @s[tag=button.request_cube_from_tube] if score @s button.status matches 0 if score $var tube.phase matches -1 run scoreboard players set $var quest.chute 1
execute if entity @s[tag=button.request_cube_from_tube] if score @s button.status matches 0 if score $var tube.phase matches -1 run scoreboard players set $var tube.phase 0
execute if entity @s[tag=button.library_enter] unless score @s button.can_use matches 0 if score $var bookshelf.complete matches 1 run scoreboard players set $var bookshelf.script 0
execute if entity @s[tag=button.library_enter] unless score @s button.can_use matches 0 if score $var bookshelf.complete matches 1 run function animated_java:button/animations/quick_press/stop
execute if entity @s[tag=button.library_enter] unless score @s button.can_use matches 0 if score $var bookshelf.complete matches 1 run function animated_java:button/animations/long_press/play
execute if entity @s[tag=button.library_enter] unless score @s button.can_use matches 0 if score $var bookshelf.complete matches 1 run scoreboard players add @s button.can_use 0
execute if entity @s[tag=button.temple_open] unless score @s button.can_use matches 0 if score @s button.status matches 0 as @e[tag=button.main,limit=1,sort=nearest,distance=0.5..] at @s run scoreboard players set @s button.can_use 1
execute if entity @s[tag=button.temple_open] unless score @s button.can_use matches 0 if score @s button.status matches 0 as @e[tag=button.main,limit=1,sort=nearest,distance=0.5..] at @s run scoreboard players set @s button.status 0
execute if entity @s[tag=button.temple_open] unless score @s button.can_use matches 0 if score @s button.status matches 0 as @e[tag=button.main,limit=1,sort=nearest,distance=0.5..] at @s run function animated_java:button/animations/hold_out/play
execute if entity @s[tag=button.temple_open] unless score @s button.can_use matches 0 if score @s button.status matches 0 positioned -5.98 4.00 17.45 run function door:open
execute if entity @s[tag=button.temple_open] unless score @s button.can_use matches 0 if score @s button.status matches 0 run scoreboard players set @s button.can_use 0
execute if entity @s[tag=button.temple_close] unless score @s button.can_use matches 0 if score @s button.status matches 0 as @e[tag=button.main,limit=1,sort=nearest,distance=0.5..] at @s run scoreboard players set @s button.can_use 1
execute if entity @s[tag=button.temple_close] unless score @s button.can_use matches 0 if score @s button.status matches 0 as @e[tag=button.main,limit=1,sort=nearest,distance=0.5..] at @s run scoreboard players set @s button.status 0
execute if entity @s[tag=button.temple_close] unless score @s button.can_use matches 0 if score @s button.status matches 0 as @e[tag=button.main,limit=1,sort=nearest,distance=0.5..] at @s run function animated_java:button/animations/hold_out/play
execute if entity @s[tag=button.temple_close] unless score @s button.can_use matches 0 if score @s button.status matches 0 positioned -5.98 4.00 17.45 run function door:close
execute if entity @s[tag=button.temple_close] unless score @s button.can_use matches 0 if score @s button.status matches 0 run scoreboard players set @s button.can_use 0
execute if entity @s[tag=button.gun_fire] unless score @s button.can_use matches 0 if score @s button.status matches 0 run scoreboard players set $var gun.fire 0
execute if entity @s[tag=button.timeline_next] if score @s button.status matches 0 if score $var timeline.image = $var timeline.current_image run scoreboard players add $var timeline.image 1
execute if entity @s[tag=button.lab_toggle_map] if score @s button.status matches 0 run scoreboard players set $var map.step -1
execute if entity @s[tag=button.lab_toggle_map] if score @s button.status matches 0 run scoreboard players set $var map.type 1
execute if entity @s[tag=button.lab_toggle_map] if score @s button.status matches 0 as @a[tag=map.shown] at @s run function map:type/set/eye_path
execute if entity @s[tag=button.lab_toggle_map] if score @s button.status matches 0 as @a[tag=playing,limit=1,sort=nearest] at @s run function map:type/set/eye_path
execute if entity @s[tag=button.lab_toggle_map] if score @s button.status matches 1 run scoreboard players set $var map.type 0
execute if entity @s[tag=button.lab_toggle_map] if score @s button.status matches 1 run scoreboard players set $var map.step -1
execute if entity @s[tag=button.lab_toggle_map] if score @s button.status matches 1 as @a[tag=map.shown] at @s run function map:type/set/maze
execute if entity @s[tag=button.lab_toggle_map] if score @s button.status matches 1 as @a[tag=playing,limit=1,sort=nearest] at @s run function map:type/set/maze
execute if entity @s[tag=button.start_door_1] run scoreboard players set $var start.button_1 0
execute if entity @s[tag=button.start_door_2] run scoreboard players set $var start.button_2 0
execute if entity @s[tag=button.start_game] run function lh:start/press_start_button
execute if entity @s[tag=button.start_puzzle] if score @s button.status matches 0 run scoreboard players set $var cart.status 1
execute if entity @s[tag=button.start_puzzle] if score @s button.status matches 1 run scoreboard players set $var cart.status 0
execute if entity @s[tag=button.totem_add] if score @s button.status matches 0 run scoreboard players add $var totem.count 1
execute if entity @s[tag=button.power_pistons] if score @s button.status matches 0 run fill 4 2 -25 4 2 -18 minecraft:redstone_block
execute if entity @s[tag=button.water_activate] if score @s button.status matches 0 run function cinematic:queue/water
execute if entity @s[tag=button.end_send_stats] if score @s button.status matches 0 run function lh:end/stats/create
execute if entity @s[tag=button.end_send_socials] if score @s button.status matches 0 run tellraw @p [{"text":"\nUrgle","color":"yellow"},{"text":" -","color":"gray"},{"text":" \uE861 ","color":"white"},{"text":"Youtube","bold":true,"color":"red","clickEvent":{"action":"open_url","value":"https://www.youtube.com/@Urgle"}},{"text":" | \uE860 ","color":"white"},{"text":"Discord","bold":true,"color":"dark_aqua","clickEvent":{"action":"open_url","value":"https://discord.gg/hTK5236VsR"}},{"text":" (在此游玩独家地图)","color":"dark_aqua"},{"text":"\n\n"},{"text":"Vandoorea","color":"white"},{"text":" -","color":"gray"},{"text":" \uE861 ","color":"white"},{"text":"Youtube","bold":true,"color":"red","clickEvent":{"action":"open_url","value":"https://www.youtube.com/@Vandoorea"}},{"text":"\n"},{"text":"Scott Buckley","color":"white"},{"text":" -","color":"gray"},{"text":" \uE861 ","color":"white"},{"text":"Youtube ","bold":true,"color":"red","clickEvent":{"action":"open_url","value":"https://www.youtube.com/@ScottBuckley"}},{"text":"|","color":"white"},{"text":" \uE862","color":"white"},{"text":" 网站","bold":true,"color":"white","clickEvent":{"action":"open_url","value":"https://scottbuckley.com.au/library"}},{"text":" (无版权音乐!)","color":"white"},{"text":"\nAandeel","color":"white"},{"text":" -","color":"gray"},{"text":" \uE862","color":"white"},{"text":" 网站","bold":true,"color":"white","clickEvent":{"action":"open_url","value":"https://aandeel.co.uk/"}},{"text":"","color":"white"},{"text":"\n\n"}]
execute if entity @s[tag=button.gun_y] if score @s button.status matches 0 run kill @e[tag=gun_button.alert,distance=..1]
execute if entity @s[tag=button.gun_x] if score @s button.status matches 0 run kill @e[tag=gun_button.alert,distance=..1]




execute unless score @s button.can_use matches 0 if score @s[tag=!button.gun_fire,tag=!button.temple_open,tag=!button.temple_close] button.type matches 3 run scoreboard players set @s button.cooldown_type_3 15
execute unless score @s button.can_use matches 0 run scoreboard players add @s button.status 1
execute unless score @s button.can_use matches 0 unless score @s button.cooldown_type_3 matches 1.. if score @s button.status matches 2.. run scoreboard players set @s button.status 0
execute unless score @s button.can_use matches 0 unless score @s button.cooldown_type_3 matches 1.. if score @s button.type matches 0 run scoreboard players set @s button.status 0

execute if score @s button.type matches 1 if score @s button.status matches 1 run scoreboard players set @s button.can_use 0


execute if entity @s[tag=button.deepslate] unless score @s button.can_use matches 0 if score @s button.status matches 1 run scoreboard players set @e[tag=effect.lantern] effect.lantern.script 0
execute if entity @s[tag=button.deepslate] unless score @s button.can_use matches 0 if score @s button.status matches 1 run scoreboard players set @s button.can_use 0
