
execute if score $var cinematic.checks matches 4..8 as @e[tag=eye.main] at @s run playsound block.fire.extinguish block @a ~ ~ ~ 0.05 0
execute if score $var cinematic.checks matches 4..8 as @e[tag=eye.main] at @s run particle smoke ~ ~0.3 ~ 0.25 0.25 0.25 0 4

execute if score $var cinematic.checks matches 4..7 run scoreboard players remove $var eye.health 15
execute if score $var cinematic.checks matches 8.. run scoreboard players add $var eye.health 15

execute if score $var cinematic.checks matches 0 run schedule clear eye:teleport/here
execute if score $var cinematic.checks matches 0 run scoreboard players set $var map.blink -1
execute if score $var cinematic.checks matches 0 run function eye:teleport/here {x:4, y:1}
execute if score $var cinematic.checks matches 0 run scoreboard players set $var eye.glow_type 2
execute if score $var cinematic.checks matches 0 run scoreboard players set $var eye.max_speed 50
execute if score $var cinematic.checks matches 0 run execute as @e[tag=eye.main] at @s run teleport @s ~-2 ~ ~
execute if score $var cinematic.checks matches 0 run scoreboard players set $cinematic cinematic.wait 5

execute if score $var cinematic.checks matches 2 run execute as @e[tag=eye.main] at @s run function eye:effect/act/wander/walk
execute if score $var cinematic.checks matches 2 run scoreboard players set $cinematic cinematic.wait 105

execute if score $var cinematic.checks matches 4 run scoreboard players set $var eye.max_speed 15
execute if score $var cinematic.checks matches 4 run scoreboard players set $cinematic cinematic.wait 13

execute if score $var cinematic.checks matches 6 run execute as @e[tag=eye.main] at @s run function eye:effect/act/shatter
execute if score $var cinematic.checks matches 6 run scoreboard players set $cinematic cinematic.wait 90

execute if score $var cinematic.checks matches 8 run execute as @a run scoreboard players set @s music.mood 6
execute if score $var cinematic.checks matches 8 run execute as @a run function player:music/new
execute if score $var cinematic.checks matches 8 run execute as @e[tag=eye.main] at @s run particle minecraft:flash ~ ~0.3 ~ 0 0 0 1 2
execute if score $var cinematic.checks matches 8 run execute as @e[tag=eye.main] at @s run particle minecraft:explosion_emitter ~ ~0.3 ~ 0 0 0 1 2
execute if score $var cinematic.checks matches 8 run execute as @e[tag=eye.main] at @s run playsound minecraft:block.respawn_anchor.deplete block @a ~ ~ ~ 1 0
execute if score $var cinematic.checks matches 8 run execute as @e[tag=eye.main] at @s run playsound minecraft:item.trident.thunder block @a ~ ~ ~ 10 0.5
execute if score $var cinematic.checks matches 8 run execute as @e[tag=eye.main] at @s run playsound minecraft:entity.lightning_bolt.thunder block @a ~ ~ ~ 10 0.5
execute if score $var cinematic.checks matches 8 run execute as @e[tag=eye.main] at @s run playsound minecraft:entity.wither.spawn block @a ~ ~ ~ 10 0
execute if score $var cinematic.checks matches 8 run execute as @e[tag=eye.main] at @s run playsound minecraft:ui.toast.challenge_complete block @a ~ ~ ~ 1 1
execute if score $var cinematic.checks matches 8 run execute as @e[tag=eye.main] at @s run advancement grant @a only lh:progress/free_the_halls
execute if score $var cinematic.checks matches 8 run scoreboard players set $var eye.leaking 15
execute if score $var cinematic.checks matches 8 run scoreboard players set $var eye.max_speed 1
execute if score $var cinematic.checks matches 8 run scoreboard players set $cinematic cinematic.wait 115

execute if score $var cinematic.checks matches 10 run execute as @e[tag=eye.main] at @s run playsound effects.scroll block @a ~ ~ ~ 1 0
execute if score $var cinematic.checks matches 10 run scoreboard players set $cinematic cinematic.wait 8

execute if score $var cinematic.checks matches 12 run execute as @e[tag=eye.main] at @s run playsound minecraft:block.respawn_anchor.deplete block @a ~ ~ ~ 0.6 0.8
execute if score $var cinematic.checks matches 12 run execute as @e[tag=eye.main] at @s run playsound minecraft:entity.player.attack.crit block @a ~ ~ ~ 1
execute if score $var cinematic.checks matches 12 run execute as @e[tag=eye.main] at @s run particle crit ~ ~ ~ 0.3 0.3 0.3 1 100
execute if score $var cinematic.checks matches 12 run function eye:teleport/relocate
execute if score $var cinematic.checks matches 12 run scoreboard players set $cinematic cinematic.wait 50

execute if score $var cinematic.checks matches 14 run title @a times 1.5s 4t 1.5s
execute if score $var cinematic.checks matches 14 run execute as @a run function player:blind/black
execute if score $var cinematic.checks matches 14 run function eye:teleport/start
execute if score $var cinematic.checks matches 14 run scoreboard players set $cinematic cinematic.wait 32

execute if score $var cinematic.checks matches 16 run tellraw @a {"text":"\n捕获全知之眼并将其带到传送门框架!\n","color":"yellow"}
execute if score $var cinematic.checks matches 16 run execute as @e[tag=eye.main] at @s run tag @s add orb_broken
execute if score $var cinematic.checks matches 16 run execute as @e[tag=eye.main] at @s run scoreboard players set $var eye.health 1000
execute if score $var cinematic.checks matches 16 run scoreboard players set $var quest.eye 1
execute if score $var cinematic.checks matches 16 run bossbar set eye visible true
execute if score $var cinematic.checks matches 16 run function cinematic:end


function cinematic:operation/manage_time
scoreboard players add $var cinematic.checks 1