

execute if score $var cinematic.checks matches 0 run playsound entity.wither.spawn ambient @a ~ ~ ~ 1 0.5
execute if score $var cinematic.checks matches 0 run setblock 12 5 7 minecraft:red_sandstone_stairs[facing=east]
execute if score $var cinematic.checks matches 0 run setblock 10 5 7 minecraft:red_sandstone_stairs[facing=west]
execute if score $var cinematic.checks matches 0 run fill 11 5 7 11 6 8 air
execute if score $var cinematic.checks matches 0 run scoreboard players set $cinematic cinematic.wait 10

execute if score $var cinematic.checks matches 2 run scoreboard players set $cinematic cinematic.wait 55


#first turn - obsidian to red room
execute if score $var cinematic.checks matches 4 run data modify storage cinematic movement.dz set value {goal:-0.1, increment:-0.002}
execute if score $var cinematic.checks matches 4 run scoreboard players set $cinematic cinematic.wait 15

execute if score $var cinematic.checks matches 6 run data modify storage cinematic movement.rx set value {goal:3, increment:0.1001}
execute if score $var cinematic.checks matches 6 run scoreboard players set $cinematic cinematic.wait 30

execute if score $var cinematic.checks matches 8 run data modify storage cinematic movement.rx set value {goal:0, increment:-0.1}
execute if score $var cinematic.checks matches 8 run scoreboard players set $cinematic cinematic.wait 10

execute if score $var cinematic.checks matches 10 run data modify storage cinematic movement.dz set value {goal:-0.175, increment:-0.002}
execute if score $var cinematic.checks matches 10 run scoreboard players set $cinematic cinematic.wait 55


#second turn - delta room to hallway
execute if score $var cinematic.checks matches 12 run data modify storage cinematic movement.rx set value {goal:3.75, increment:0.18}
execute if score $var cinematic.checks matches 12 run scoreboard players set $cinematic cinematic.wait 25

execute if score $var cinematic.checks matches 14 run data modify storage cinematic movement.rx set value {goal:0, increment:-0.196}
execute if score $var cinematic.checks matches 14 run scoreboard players set $cinematic cinematic.wait 20

execute if score $var cinematic.checks matches 16 run execute positioned 14.91 4.00 -3.44 run function door:close
execute if score $var cinematic.checks matches 16 run scoreboard players set $cinematic cinematic.wait 88

execute if score $var cinematic.checks matches 18 run execute positioned 29.76 4.00 -3.51 run function door:close
execute if score $var cinematic.checks matches 18 run scoreboard players set $cinematic cinematic.wait 12

execute if score $var cinematic.checks matches 20 run data modify storage cinematic movement.dz set value {goal:-0.1, increment:0.002}
execute if score $var cinematic.checks matches 20 run scoreboard players set $cinematic cinematic.wait 20

#third turn - water leak room to origin
execute if score $var cinematic.checks matches 22 run data modify storage cinematic movement.rx set value {goal:-4.6, increment:-0.196}
execute if score $var cinematic.checks matches 22 run scoreboard players set $cinematic cinematic.wait 20

execute if score $var cinematic.checks matches 24 run data modify storage cinematic movement.rx set value {goal:0, increment:0.196}
execute if score $var cinematic.checks matches 24 run scoreboard players set $cinematic cinematic.wait 20

execute if score $var cinematic.checks matches 26 run data modify storage cinematic movement.dz set value {goal:-0.08, increment:0.001}
execute if score $var cinematic.checks matches 26 run scoreboard players set $cinematic cinematic.wait 37

#fourth turn - origin to start platform
execute if score $var cinematic.checks matches 28 run data modify storage cinematic movement.rx set value {goal:4.6, increment:0.196}
execute if score $var cinematic.checks matches 28 run scoreboard players set $cinematic cinematic.wait 20

execute if score $var cinematic.checks matches 30 run data modify storage cinematic movement.rx set value {goal:0, increment:-0.196}
execute if score $var cinematic.checks matches 30 run scoreboard players set $cinematic cinematic.wait 40

execute if score $var cinematic.checks matches 32 run data modify storage cinematic movement.dz set value {goal:0, increment:0.002}
execute if score $var cinematic.checks matches 32 run scoreboard players set $cinematic cinematic.wait 50

execute if score $var cinematic.checks matches 34 run title @a times 0 35 5
execute if score $var cinematic.checks matches 34 run scoreboard players set $var quest.power 0
execute if score $var cinematic.checks matches 34 run scoreboard players set $var game.stage 1
execute if score $var cinematic.checks matches 34 run function map:info/default
execute if score $var cinematic.checks matches 34 run title @a subtitle {"text":"逃离失落之厅","bold":true,"color":"gold"}
execute if score $var cinematic.checks matches 34 run title @a title {"text":"","bold":true,"color":"gold"}
execute if score $var cinematic.checks matches 34 run playsound entity.wither.spawn ambient @a ~ ~ ~ 1 0.75
execute if score $var cinematic.checks matches 34 run teleport @s ~ ~ ~ 90 0
execute if score $var cinematic.checks matches 34 run effect give @a slowness 2 0 true
execute if score $var cinematic.checks matches 34 run scoreboard players set $cinematic cinematic.wait 10

execute if score $var cinematic.checks matches 36 run fill 11 6 8 11 5 8 deepslate_tiles
execute if score $var cinematic.checks matches 36 run setblock 11 6 7 red_sandstone
execute if score $var cinematic.checks matches 36 run fill 12 5 7 10 5 7 red_sandstone
execute if score $var cinematic.checks matches 36 run setblock 11 5 7 minecraft:chiseled_red_sandstone
execute if score $var cinematic.checks matches 36 run execute positioned 11.25 4.00 0.02 run function door:open
execute if score $var cinematic.checks matches 36 run execute as @a at @s run scoreboard players set @s music.mood 0
execute if score $var cinematic.checks matches 36 run execute as @a at @s run function player:music/new
execute if score $var cinematic.checks matches 36 run tellraw @a [{"text":"\n确保你的音乐音量设为了100%!","color":"gray"},{"text":"\n当遇到困难或需要帮助时可以运行'/trigger [...]'命令 \n","color":"dark_gray","italic":true}]
execute if score $var cinematic.checks matches 36 run function cinematic:abrupt_end



function cinematic:operation/manage_time
scoreboard players add $var cinematic.checks 1