
tag @s remove cube.got_interacted
scoreboard players remove @s cube.collision.cooldown 1
execute if score @s prev.my = @s my run scoreboard players add @s cube.time.ungrabbed 1
scoreboard players add @s cube.time.released 1
scoreboard players set @s[tag=cube.is_grabbed] cube.time.released 0

execute if score @s cube.time.ungrabbed matches 1 unless entity @s[tag=cube.non_solid] run data modify entity @s Motion set value []
execute if score @s cube.time.released matches 1 if entity @s[tag=cube.non_solid] run scoreboard players operation @s bounce.mx = @s prev.mx
execute if score @s cube.time.released matches 1 if entity @s[tag=cube.non_solid] run scoreboard players operation @s bounce.my = @s prev.my
execute if score @s cube.time.released matches 1 if entity @s[tag=cube.non_solid] run scoreboard players operation @s bounce.mz = @s prev.mz
execute if score @s cube.time.released matches 1 if entity @s[tag=cube.non_solid] run scoreboard players operation @s bounce.mx *= 12 num
execute if score @s cube.time.released matches 1 if entity @s[tag=cube.non_solid] run scoreboard players operation @s bounce.my *= 12 num
execute if score @s cube.time.released matches 1 if entity @s[tag=cube.non_solid] run scoreboard players operation @s bounce.mz *= 12 num
execute if score @s cube.time.released matches 1 if entity @s[tag=cube.non_solid] run scoreboard players operation @s bounce.mx /= 10 num
execute if score @s cube.time.released matches 1 if entity @s[tag=cube.non_solid] run scoreboard players operation @s bounce.my /= 10 num
execute if score @s cube.time.released matches 1 if entity @s[tag=cube.non_solid] run scoreboard players operation @s bounce.mz /= 10 num
execute if score @s cube.time.released matches 1.. if entity @s[tag=cube.non_solid] run function cube:bounce
execute if score @s cube.time.released matches 1.. if entity @s[tag=!cube.non_solid] run data modify entity @s Motion[0] set value 0.0d
execute if score @s cube.time.released matches 1.. if entity @s[tag=!cube.non_solid] run data modify entity @s Motion[2] set value 0.0d
execute if score @s cube.time.ungrabbed matches 50 unless entity @s[tag=cube.metal_box] unless score @e[tag=cube.item,limit=1,sort=nearest] cube.item matches 1.. run kill @e[tag=cube.item,limit=1,sort=nearest]

execute if score @s prev.cube.collision matches 1 if score @s cube.collision.cooldown matches ..0 unless block ~ ~-0.4 ~ #wool run function cube:collision
scoreboard players operation @s prev.cube.collision = @s cube.collision
scoreboard players operation @s prev.cube.collision.x = @s cube.collision.x
scoreboard players operation @s prev.cube.collision.y = @s cube.collision.y
scoreboard players operation @s prev.cube.collision.z = @s cube.collision.z

execute on vehicle if entity @s[tag=cart.main,tag=!cart.special] on passengers run ride @s dismount

#teleport holder if is linked to one
execute if score @s cube.time.ungrabbed matches ..100 if entity @s[tag=cube.is_linked,tag=!cube.lodestone,tag=!cube.obsidian,tag=!cube.tube_quartz,tag=!cube.non_solid] run function cube:teleport_holder
execute if entity @s[tag=cube.lodestone] run function cube:teleport_holder
execute if entity @s[tag=cube.obsidian] run function cube:teleport_holder
execute if entity @s[tag=cube.tube_quartz] run function cube:teleport_holder
execute if entity @s[tag=cube.non_solid] run function cube:teleport_holder


#if cube is not on ground, run position operations
execute if score @s[tag=!cube.non_solid] cube.time.ungrabbed matches ..10 run function cube:position_operations
execute if entity @s[tag=cube.non_solid] run function cube:position_operations
execute unless score @s[tag=!cube.non_solid] cube.time.ungrabbed matches ..10 if entity @e[tag=cube.hitbox,distance=..5] run function cube:position_operations
execute if entity @s[tag=cube.in_temple] run tag @s add in_temple

execute store result score @s pos.y run data get entity @s Pos[1]
execute unless entity @s[tag=cube.killed] unless score @e[tag=cube.item,limit=1,sort=nearest,distance=..5] cube.item matches 200 if score @s pos.y matches ..-1 run playsound minecraft:entity.enderman.teleport block @a ~ ~ ~ 1
execute unless entity @s[tag=cube.killed] unless score @e[tag=cube.item,limit=1,sort=nearest,distance=..5] cube.item matches 200 if score @s pos.y matches ..-1 run teleport @s @p[tag=playing]
execute unless entity @s[tag=cube.killed] if score @s pos.y matches ..-40 run teleport @s @p[tag=playing]
execute unless entity @s[tag=cube.killed] if score @s pos.y matches ..-64 run function cube:kill




execute if entity @s[tag=cube.metal_box] if entity @e[type=minecart,tag=cart.empty,tag=cart.special,tag=!cart.refuse_cube,distance=0.5..1.2] run damage @e[tag=cart.empty,distance=..1.2,limit=1,sort=nearest] 3 generic_kill
execute if entity @s[tag=cube.metal_box] if entity @e[type=minecart,tag=cart.empty,tag=cart.special,tag=!cart.refuse_cube,distance=0.5..1.2] run playsound minecraft:item.armor.equip_iron block @a ~ ~ ~ 1 0.8
execute if entity @s[tag=cube.metal_box] if entity @e[type=minecart,tag=cart.empty,tag=cart.special,tag=!cart.refuse_cube,distance=0.5..1.2] run ride @s mount @e[tag=cart.empty,distance=..1.2,limit=1,sort=nearest]

#primed loop
execute if entity @s[tag=cube.tnt] run function cube:primed_loop

#lodestone effect if held
execute if entity @s[tag=cube.lodestone] if score @s cube.held matches 0 if score @s cube.prev.held matches 1 run function cube:lodestone/no_gravity
execute if entity @s[tag=cube.lodestone] if score @s cube.held matches 1 if score @s cube.prev.held matches 0 run function cube:lodestone/gravity
execute if entity @s[tag=cube.lodestone] if score @s cube.held matches 0 run data modify entity @s Motion[1] set value -0.0035d

execute if entity @s[tag=cube.metal_box] if score @s cube.held matches 1 if score @e[tag=effect.alarm,limit=1,sort=nearest] alarm.timer matches 60.. run scoreboard players set @e[tag=effect.alarm,limit=1,sort=nearest] alarm.timer 50

execute if entity @s[tag=cube.obsidian] run function cube:obsidian_loop




scoreboard players operation @s cube.prev.held = @s cube.held
scoreboard players set @s cube.held 0

tag @s remove cube.is_grabbed


effect give @s slowness infinite 200 true
effect give @s invisibility infinite 200 true
effect give @s resistance infinite 200 true
