scoreboard players remove @s[scores={eye.anim_id=1..4}] eye.pulse 1
scoreboard players remove @s[scores={eye.anim_id=7}] eye.pulse 1
scoreboard players remove @s[scores={eye.anim_id=8..9}] eye.pulse 1
scoreboard players set @s[scores={eye.pulse=100..}] eye.pulse 1


execute if entity @s[tag=orb_broken] run scoreboard players set $var eye.max_speed 0
execute if entity @s[tag=orb_broken] run scoreboard players set @s calc.5 50
execute if entity @s[tag=orb_broken] run scoreboard players operation @s calc.5 *= $var eye.health
execute if entity @s[tag=orb_broken] run scoreboard players operation @s calc.5 /= 1000 num
execute if entity @s[tag=orb_broken] run scoreboard players set @s calc.4 50
execute if entity @s[tag=orb_broken] run scoreboard players operation @s calc.4 -= @s calc.5
execute if entity @s[tag=orb_broken] run scoreboard players set $var eye.max_speed 75
execute if entity @s[tag=orb_broken] run scoreboard players operation $var eye.max_speed += @s calc.4
execute if entity @s[tag=orb_broken] run execute if score $var eye.max_speed matches 120.. run scoreboard players set $var eye.max_speed 120
execute if entity @s[tag=orb_broken] run scoreboard players set $var eye.glow_type 2




function eye:effect/walk_cycle
function eye:effect/glow.loop
execute if score @s eye.pulse matches ..0 run function eye:pulse
execute if score @s eye.attack matches -10.. run function eye:effect/attack.loop

execute anchored eyes run fill ~3 ~3 ~3 ~-3 ~-3 ~-3 air replace light
execute unless score $var cinematic.id matches 7 if entity @s[tag=!orb_broken] anchored eyes run fill ~1 ~1 ~1 ~-1 ~-1 ~-1 light[level=14] replace air
execute unless score $var cinematic.id matches 7 if entity @s[tag=orb_broken] anchored eyes run fill ~1 ~1 ~1 ~-1 ~-1 ~-1 light[level=8] replace air

execute positioned ~ ~-0.05 ~ run particle dust 0.071 0.322 0.118 0.75 ^ ^ ^-0.3 0.1 0.1 0.1 0 2

function eye:path/loop
function eye:effect/float

execute if score $var eye.health matches ..0 run function eye:kill
execute if score $var eye.rapid_damage matches 1.. run scoreboard players remove $var eye.rapid_damage 1
execute if score $var eye.rapid_damage matches 300.. if score @s eye.anim_id matches 8..9 if score $var eye.health matches 150.. run function eye:effect/act/teleport/out

execute if score $var eye.leaking matches 1.. store result storage eye leak.value int 1 run scoreboard players get $var eye.leaking
execute if score $var eye.leaking matches 1.. run function eye:effect/leak with storage eye leak

