

#get map coordinates -- here, the z axis is represented as the y axis, for consistency purposes with the minimap
execute store result score @s x run data get entity @s Pos[0]
execute store result score @s y run data get entity @s Pos[2]
execute store result score @s rx run data get entity @s Rotation[0] 10

#offset position depending on the direction (center is 3 blocks large, so offset by 1 block)
execute if entity @s[tag=direction.north] run scoreboard players remove @s y 1
execute if entity @s[tag=direction.south] run scoreboard players add @s y 1
execute if entity @s[tag=direction.west] run scoreboard players remove @s x 1
execute if entity @s[tag=direction.east] run scoreboard players add @s x 1





# -- check if the eye exited / entered the middle of the room

#check if aligned in the middle of a room on the x axis
scoreboard players operation @s calc.1 = @s x
scoreboard players add @s calc.1 17
scoreboard players operation @s calc.1 %= 7 num

#check if aligned in the middle of a room on the y axis
scoreboard players operation @s calc.2 = @s y
scoreboard players add @s calc.2 39
scoreboard players operation @s calc.2 %= 7 num

execute if score @s map.x matches -4 if score @s map.y matches 7 run tag @s add in_temple

#check if eye is in the middle, if so enter middle mode, if it reaches its final rotation it exits the middle mode
#execute if entity @s[tag=eye.in_mid] run particle block_marker barrier ~ ~2.1 ~ 0 0 0 0 1

execute if entity @s[tag=eye.in_mid] if score @s[tag=direction.north] rx matches -1800..-1780 run function eye:path/mid/exit
execute if entity @s[tag=eye.in_mid] if score @s[tag=direction.north] rx matches 1780..1800 run function eye:path/mid/exit
execute if entity @s[tag=eye.in_mid] if score @s[tag=direction.south] rx matches -20..20 run function eye:path/mid/exit
execute if entity @s[tag=eye.in_mid] if score @s[tag=direction.east] rx matches -920..-880 run function eye:path/mid/exit
execute if entity @s[tag=eye.in_mid] if score @s[tag=direction.west] rx matches 880..920 run function eye:path/mid/exit

execute unless entity @s[tag=eye.in_mid] if score @s[scores={x=-17..40}] calc.1 matches 0 if score @s[scores={y=-39..18}] calc.2 matches 0 run function eye:path/mid/enter



#turn if inside the middle
scoreboard players operation @s calc.5 = $var eye.speed
scoreboard players operation @s calc.5 *= 1900 num
scoreboard players operation @s calc.5 /= 50 num
execute store result storage eye angle.value float 0.001 run scoreboard players get @s calc.5

function eye:path/apply_direction with storage eye angle




#continuously walk forward while aligning to the center axis if possible
execute store result storage eye speed.value int 1 run scoreboard players get $var eye.speed
execute unless entity @s[tag=eye.skip_tp] run function eye:path/walk with storage eye speed
tag @s remove eye.skip_tp



#teleport the eye to the tracer entity
#execute store result entity @e[tag=allay,limit=1] Pos[0] double 1 run data get entity @s Pos[0]
#data modify entity @e[tag=allay,limit=1] Pos[1] set value 15.0d


#execute as @e[tag=eye.all] at @s run teleport @s @e[tag=tracer,limit=1]
scoreboard players operation $eye map.x = @s map.x
scoreboard players operation $eye map.y = @s map.y