
import os

path = "C:/Users/"+os.getenv('username')+"/AppData/Roaming/.minecraft/saves/Escape the Lost Halls - v3.5/datapacks/Escape the Lost Halls/data/map/functions/info/"

map = [
    ["→", "↓", ".", "→", "↓", "→", "→", "→", "↓"],
    ["↑", "→", "↓", "↑", "→", "↑", "↓", "←", "←"],
    ["↑", "←", "→", "↑", "↑", "↓", "→", "↓", "."],
    ["↓", "+", "←", "←", "←", "←", "←", "→", "↓"],
    ["→", "↑", ".", ".", ".", ".", "↑", ".", "↓"],
    [".", ".", "→", "→", "→", "→", "↑", "↓", "←"],
    ["↓", "←", "↑", "↓", "←", "←", "←", "↓", "."],
    ["→", "+", "↑", "↓", ".", "→", "↑", "→", "↓"],
    [".", "↑", "←", "←", ".", "↑", "←", "←", "←"],
]

#clear all files
for y in range(9):
    open(path + "get/y/" + str(y) +"/row.mcfunction", "w").close()

open(path + "default.mcfunction", "w").close()
open(path + "retrieve.mcfunction", "w").close()


#generate the default storage value
entries = {}
print(entries)

for y in range(9):
    for x in range(9):
        symbols = ["→", "←", "↓", "↑", "+", "."] 
        meaning = [180, 0, -90, 90, -1, "NULL"]   
        entry = {"eye_direction": meaning[symbols.index(map[y][x])]}
        entries[str(x-4)+str(8-y)] = entry

with open(path + "default.mcfunction", "a") as f:
    f.write("data modify storage map info set value "+ str(entries).replace("'", "\""))


#generate the mcfunction files that will allow data to be retrieved from storage
for y in range(9):
    entries = ""
    for x in range(9):
        entry = "execute if score @s map.x matches "+ str(x-4) +" run data modify storage minecraft:map room set from storage map info."+ str(x-4)+str(y) + "\n"
        entries += entry

    with open(path + "get/y/" + str(y) +"/row.mcfunction", "a") as f:
        f.write(entries)



#generate retrieve.mcfunction, which will retrieve data from the room @s is in to the memory storage, which will then be read
for y in range(9):
    entry = "execute if score @s map.y matches "+ str(y) +" run function map:info/get/y/"+str(y) + "/row\n"

    with open(path + "retrieve.mcfunction", "a") as f:
        f.write(entry)
