
#particle dust 1 0 0 1 ~ ~ ~ 0 0 0 5 0

#check criteria for being pressed
execute if entity @s[tag=plate.reusable] run scoreboard players set @s plate.pressed 0
scoreboard players set @s plate.has_cube 0
scoreboard players set @s plate.has_player 0
scoreboard players set @s plate.has_lightweight_cube 0

execute positioned ~ ~-0.70 ~ if entity @e[tag=cube.display,distance=..1.2] run scoreboard players set @s plate.has_cube 1
execute positioned ~ ~-0.70 ~ if entity @e[tag=cube.display_lightweight,distance=..1.2] run scoreboard players set @s plate.has_lightweight_cube 1
execute if entity @s[tag=plate.glass] positioned ~ ~-0.70 ~ if entity @e[tag=cube.display_lightweight,distance=..1.2] if score @e[tag=cube.main,limit=1,sort=nearest] cube.shatter matches 0 run advancement grant @a only lh:special/ice_intact
execute positioned ~ ~-0.70 ~ if entity @a[tag=playing,distance=..1.2] run scoreboard players set @s plate.has_player 1

execute if entity @s[tag=plate.stone,scores={plate.has_cube=1}] run scoreboard players set @s plate.pressed 1
execute if entity @s[tag=plate.stone,scores={plate.has_player=1}] run scoreboard players set @s plate.pressed 1
execute if entity @s[tag=plate.gold,scores={plate.has_player=1}] run scoreboard players set @s plate.pressed 1
execute if entity @s[tag=plate.diamond,scores={plate.has_player=1}] run scoreboard players set @s plate.pressed 1
execute if entity @s[tag=plate.quartz,scores={plate.has_cube=1}] run scoreboard players set @s plate.pressed 1
execute if entity @s[tag=plate.quartz,scores={plate.has_player=1}] run scoreboard players set @s plate.pressed 1
execute if entity @s[tag=plate.netherite,scores={plate.has_cube=1}] run scoreboard players set @s plate.pressed 1
execute if entity @s[tag=plate.glass,scores={plate.has_lightweight_cube=1}] run scoreboard players set @s plate.pressed 1
execute if entity @s[tag=plate.cart] positioned ~ ~-0.70 ~ if entity @e[tag=cart,distance=..1.0] run scoreboard players set @s plate.pressed 1
execute if entity @s[tag=plate.cart] unless score $var game.starting matches 1 if score @s plate.pos matches -5 positioned ~ ~-0.70 ~ if entity @e[tag=cart,distance=..1.0] run execute positioned 49.12 80.00 -1002.55 run function door:open
execute if entity @s[tag=plate.cart] unless score @s plate.pos matches -5 positioned ~ ~-0.70 ~ unless entity @e[tag=cart,distance=..1.0] run execute positioned 49.12 80.00 -1002.55 run function door:close

#increment its pos depending if plate is pressed
execute if score @s plate.pressed matches 1 if score @s plate.pos matches -4.. run scoreboard players remove @s plate.pos 1
execute if score @s plate.pressed matches 0 if score @s plate.pos matches ..-1 run scoreboard players add @s plate.pos 1


#if the plate is pressed and is a checkpoint plate, run the checkpoint checks
execute if score @s plate.pressed matches 1 if entity @s[tag=plate.cp] unless entity @e[tag=effect.cp,distance=..5] positioned ~ ~1 ~ run function effect:cp/summon


#position checks - teleport to position
execute positioned ~ ~0.75 ~ as @e[tag=plate.display,limit=1,sort=nearest] at @s run teleport @s @e[type=marker,tag=plate.main,limit=1,sort=nearest]
execute if score @s plate.pos matches 0 run teleport @e[tag=plate.display,limit=1,sort=nearest] ~ ~0.3 ~
execute if score @s plate.pos matches -1 run teleport @e[tag=plate.display,limit=1,sort=nearest] ~ ~0.25 ~
execute if score @s plate.pos matches -2 run teleport @e[tag=plate.display,limit=1,sort=nearest] ~ ~0.20 ~
execute if score @s plate.pos matches -3 run teleport @e[tag=plate.display,limit=1,sort=nearest] ~ ~0.15 ~
execute if score @s plate.pos matches -4 run teleport @e[tag=plate.display,limit=1,sort=nearest] ~ ~0.10 ~
execute if score @s plate.pos matches -5 run teleport @e[tag=plate.display,limit=1,sort=nearest] ~ ~0.05 ~

#clicking sounds when being pressed
execute if score @s plate.pos matches -1 run playsound minecraft:block.stone_pressure_plate.click_off ambient @a ~ ~ ~ 0.4 0
execute if score @s plate.pos matches -2 run playsound minecraft:block.stone_pressure_plate.click_off ambient @a ~ ~ ~ 0.4 0.2
execute if score @s plate.pos matches -3 run playsound minecraft:block.stone_pressure_plate.click_off ambient @a ~ ~ ~ 0.4 0.4
execute if score @s plate.pos matches -4 run playsound minecraft:block.stone_pressure_plate.click_off ambient @a ~ ~ ~ 0.4 0.6

