execute if score @s carrot_interact matches 1.. run scoreboard players set @s interact 1
scoreboard players set @s carrot_interact 0

execute if score @s fungus_interact matches 1.. run scoreboard players set @s interact 1
scoreboard players set @s fungus_interact 0


# --------- interact == right click ---------
#toggle gravity device
execute if entity @s[scores={interact=1, item.id= 100, interact.id= 1 }] anchored eyes positioned ^ ^ ^4 if entity @e[tag=cube.main,tag=cube.got_interacted,distance=..4,tag=!cube.locked] positioned ~ ~-0.5 ~ run function item:gravity/grab
execute if entity @s[scores={interact=1, item.id= 101}] run function item:gravity/release

#if player is holding a totem, remove it and set the script of the totem door to -1 so it starts opening
execute if entity @s[scores={interact=1, item.id= 200, interact.id= 2 }] run item replace entity @s weapon with air
execute if entity @s[scores={interact=1, item.id= 200, interact.id= 2 }] anchored eyes positioned ^ ^ ^3 as @e[tag=door.totem,tag=door.totem.got_interacted,distance=..4,limit=1,sort=nearest] at @s run scoreboard players set @s script -1

#teleporter and alternator
execute if entity @s[scores={interact=1, item.id= 301}] run function player:inv/set/normal
execute if entity @s[scores={interact=1, item.id= 311}] run function player:inv/set/normal
execute if entity @s[scores={interact=1, item.id= 300}] if score @s player.device_type matches 1 run function player:inv/set/teleporter
execute if entity @s[scores={interact=1, item.id= 310}] if score @s player.device_type matches 2 if entity @s[tag=alternator_given] run function player:inv/set/alternator

#checkpoint buttons
execute if entity @s[scores={interact=1, item.id= 330}] run execute positioned as @e[tag=plate.cp.alpha,limit=1,sort=nearest] run teleport @s ~ ~0.1 ~
execute if entity @s[scores={interact=1, item.id= 331}] run execute positioned as @e[tag=plate.cp.beta,limit=1,sort=nearest] run teleport @s ~ ~0.1 ~
execute if entity @s[scores={interact=1, item.id= 332}] run execute positioned as @e[tag=plate.cp.gamma,limit=1,sort=nearest] run teleport @s ~ ~0.1 ~
execute if entity @s[scores={interact=1, item.id= 333}] run execute positioned as @e[tag=plate.cp.delta,limit=1,sort=nearest] run teleport @s ~ ~0.1 ~
execute if entity @s[scores={interact=1, item.id= 334}] run execute positioned as @e[tag=plate.cp.epsilon,limit=1,sort=nearest] run teleport @s ~ ~0.1 ~
execute if entity @s[scores={interact=1, item.id= 330}] run execute positioned as @e[tag=plate.cp.alpha,limit=1,sort=nearest] run function player:inv/set/normal
execute if entity @s[scores={interact=1, item.id= 331}] run execute positioned as @e[tag=plate.cp.beta,limit=1,sort=nearest] run function player:inv/set/normal
execute if entity @s[scores={interact=1, item.id= 332}] run execute positioned as @e[tag=plate.cp.gamma,limit=1,sort=nearest] run function player:inv/set/normal
execute if entity @s[scores={interact=1, item.id= 333}] run execute positioned as @e[tag=plate.cp.delta,limit=1,sort=nearest] run function player:inv/set/normal
execute if entity @s[scores={interact=1, item.id= 334}] run execute positioned as @e[tag=plate.cp.epsilon,limit=1,sort=nearest] run function player:inv/set/normal

#layer buttons
execute if entity @s[scores={interact=1, item.id= 340}] run function player:layer/1
execute if entity @s[scores={interact=1, item.id= 341}] run function player:layer/2
execute if entity @s[scores={interact=1, item.id= 342}] run function player:layer/3
execute if entity @s[scores={interact=1, item.id= 343}] run function player:layer/4
execute if entity @s[scores={interact=1, item.id= 344}] run function player:layer/5
execute if entity @s[scores={interact=1, item.id= 345}] run function player:layer/6
execute if entity @s[scores={interact=1, item.id= 350..355}] run playsound block.stone.break block @s ~ ~ ~ 1 0
execute if entity @s[scores={interact=1, item.id= 350..355}] run scoreboard players set @s actionbar 55
execute if entity @s[scores={interact=1, item.id= 350..355}] run scoreboard players set @s actionbar.priority 300
execute if entity @s[scores={interact=1, item.id= 350..355}] run title @s actionbar {"text":"已在此维度","color":"red"}

#toggle weapon device
execute if entity @s[scores={interact=1, item.id= 700}] run function item:weapon/fire
execute if entity @s[scores={interact=1, item.id= 701}] run function item:weapon/keep_alive

#place gravity device on converter
execute if entity @s[scores={interact=1, item.id= 100, interact.id= 3}] unless score @e[tag=floater.converter,limit=1,sort=nearest] converter.step matches 0.. run function item:weapon/place_on_converter

#remove gravity device from converter
execute if entity @s[scores={interact=1, interact.id= 4}] run function item:weapon/remove_from_converter

#place eye in portal frame
execute if entity @s[scores={interact=1, interact.id= 5, item.id= 750}] run function lh:event/eye_in_portal_frame




scoreboard players set @s interact.id 0





