
function player:interact
function map:info/get_coords

function player:inv/loop
function player:music/loop

execute if entity @s[tag=map.shown] run scoreboard players add @s map.use_time 1

scoreboard players reset @s prev.2.map.x
scoreboard players reset @s prev.2.map.y
execute if score @s prev.1.map.x matches -2147483648..2147483647 if score @s prev.1.map.y matches -2147483648..2147483647 run scoreboard players operation @s prev.2.map.x = @s prev.1.map.x
execute if score @s prev.1.map.x matches -2147483648..2147483647 if score @s prev.1.map.y matches -2147483648..2147483647 run scoreboard players operation @s prev.2.map.y = @s prev.1.map.y
scoreboard players operation @s prev.2.rx = @s prev.1.rx



scoreboard players reset @s prev.1.map.x
scoreboard players reset @s prev.1.map.y
execute if score @s map.x matches -2147483648..2147483647 if score @s map.y matches -2147483648..2147483647 run scoreboard players operation @s prev.1.map.x = @s map.x
execute if score @s map.x matches -2147483648..2147483647 if score @s map.y matches -2147483648..2147483647 run scoreboard players operation @s prev.1.map.y = @s map.y
scoreboard players operation @s prev.1.rx = @s rx
execute store result score @s rx run data get entity @s Rotation[0]

scoreboard players set @s chest.interact 0
scoreboard players operation @s chest.interact += @s chest.interact_barrel
scoreboard players operation @s chest.interact += @s chest.interact_chest
execute if score @s chest.interact matches 20.. run advancement grant @s only lh:secret/chest
execute if score @s chest.interact matches 50 run tellraw @s {"text":"你还是不能打开箱子...","color":"red"}
execute if score @s chest.interact matches 50 run scoreboard players add @s chest.interact_chest 1
execute if score @s chest.interact matches 100 run tellraw @s {"text":"交流器区域的箱子都打不开。","color":"red"}
execute if score @s chest.interact matches 100 run scoreboard players add @s chest.interact_chest 1

execute if predicate player:painting run scoreboard players add @s painting.stare 1
execute if score @s painting.stare matches 1200 run advancement grant @s only lh:secret/painting
execute if score @s actionbar.priority matches ..20 if predicate player:cube run function player:action/display_description
execute if score @s actionbar.priority matches ..20 if predicate player:plate run function player:action/display_description
execute if score @s actionbar.priority matches ..20 if predicate player:misc/hourglass run function player:action/display_description
execute if score @s actionbar.priority matches ..20 if predicate player:misc/beamer run function player:action/display_description
execute if score @s actionbar.priority matches ..20 if predicate player:misc/battery_holder run function player:action/display_description
execute if score @s actionbar.priority matches ..20 if predicate player:misc/scanner run function player:action/display_description
execute if score @s actionbar.priority matches ..20 if predicate player:misc/converter run function player:action/display_description
execute if score @s actionbar.priority matches ..20 if predicate player:misc/cannon run function player:action/display_description
execute if score @s actionbar.priority matches ..20 if predicate player:advancement run function player:action/display_description



execute if score $var cinematic.status matches 1 run spectate @e[tag=cinematic,limit=1]


scoreboard players set @s player.in_observatory 0
execute if score @s x matches -28..-14 if score @s y matches -30..-6 run scoreboard players set @s player.in_observatory 1
execute if score @s map.x matches -4 if score @s map.y matches 7 run tag @s add in_temple
execute if entity @s[tag=playing,scores={map.x=1,map.y=6}] unless block -5 5 -18 minecraft:lever run scoreboard players set $var quest.button 1
execute if entity @s[tag=playing,scores={map.x=1,map.y=6}] unless block -5 5 -18 minecraft:lever run execute if score $var quest.button matches 1 if score $var event.notify_marker_button matches 0 run tellraw @a [{"text":"\n你的小地图上显示了一个新的标记:","color":"yellow"},{"text":" \uE017","color":"white","bold":false},{"text":"\n这将标记两个白桦木按钮的位置!\n","color":"gold"}]
execute if entity @s[tag=playing,scores={map.x=1,map.y=6}] unless block -5 5 -18 minecraft:lever run execute if score $var quest.button matches 1 if score $var event.notify_marker_button matches 0 run scoreboard players set $var event.notify_marker_button 1
execute if entity @s[tag=playing,scores={map.x=-2,map.y=7}] unless score $var lever.total matches 3 run scoreboard players set $var quest.lever 1
execute if entity @s[tag=playing,scores={map.x=4,map.y=2}] unless score $var totem.count matches 3 run scoreboard players set $var quest.totem 1
execute if entity @s[tag=playing,scores={map.x=-1,map.y=3}] unless score $var levers.pulled matches 3 run scoreboard players set $var quest.power 1


execute if score @s player.in_observatory matches 0 if score @s layer matches 1 if score @s player.notify_leaving_observatory matches 1 run tellraw @s [{"text":"\n"},{"text":"  当你离开房间时,你感到能量正在消散...","bold":false,"color":"#16AC37"},{"text":"\n"}]
execute if score @s player.in_observatory matches 0 if score @s layer matches 1 if score @s player.notify_leaving_observatory matches 1 run scoreboard players set @s player.notify_leaving_observatory 0

execute if score @s player.device_type matches 1 if score @s[tag=alternator_given] player.in_observatory matches 1 run function item:inv/replace_with_alternator
execute if score @s player.device_type matches 1 if score @s[tag=alternator_given] layer matches 2.. run function item:inv/replace_with_alternator
execute if score @s player.device_type matches 2 unless score @s player.in_observatory matches 1 unless score @s layer matches 2.. run function item:inv/replace_with_teleporter

#execute if entity @s[gamemode=spectator] run tag @s[tag=playing] add was_playing
#execute if entity @s[gamemode=spectator] run tag @s[tag=playing] remove playing
#execute if entity @s[gamemode=!spectator] run tag @s[tag=was_playing] add playing

execute if entity @s[gamemode=adventure] at @s positioned ~ -20 ~ run effect clear @s[distance=..20] resistance
execute if entity @s[gamemode=adventure] at @s positioned ~ -20 ~ run effect give @s[distance=..20] instant_damage 1 5 true

execute if entity @s[tag=playing] run execute store result score @s on_ground run data get entity @s OnGround
execute if score @s on_ground matches 1 unless block ~ ~-0.01 ~ #air run function player:death/store_pos

execute if score @s totem matches 0 if score @s died matches 1.. run function player:death/go_tp_cp
execute if score @s totem matches 1.. run function player:death/revive
scoreboard players set @s has_mainhand_venus_trinket 0
scoreboard players set @s has_offhand_venus_trinket 0
execute store success score @s has_mainhand_venus_trinket run execute if data entity @s SelectedItem.tag.is_venus_trinket
execute store success score @s has_offhand_venus_trinket run execute if entity @s[nbt={Inventory:[{Slot:-106b,tag:{is_venus_trinket:true}}]}]
execute if score @s has_mainhand_venus_trinket matches 1 run advancement grant @s only lh:special/venus_trinket

execute if score $var game.stage matches 1 if entity @s[gamemode=adventure] at @s positioned ~ 12 ~ if score @s player.in_observatory matches 0 if entity @s[distance=..2] run function player:death/go_tp_cp

scoreboard objectives add time_since_joined dummy
scoreboard players add @s[tag=give_items_soon] time_since_joined 1
execute if score @s time_since_joined matches 30 run function player:give_items

bossbar set cinematic players @a
function player:misc/apply_effects






























scoreboard players remove @s title 1
scoreboard players remove @s subtitle 1
execute unless score @s item.id matches 101 run scoreboard players remove @s actionbar 1

scoreboard players set @s[scores={title=..0}] title.priority -1
scoreboard players set @s[scores={subtitle=..0}] subtitle.priority -1
scoreboard players set @s[scores={actionbar=..0}] actionbar.priority -1

execute if entity @a if entity @s[tag=role.has_role,gamemode=!spectator] run function player:hologram/loop
execute as @e[tag=hologram] at @s positioned ~ ~-2.075 ~ unless entity @a[tag=role.has_role,distance=..1,gamemode=!spectator] run kill @s




execute if score @s crouch matches 1 if score @s prev.crouch matches 0 if score @s time_since_crouch matches ..7 if score $var game.stage matches 1 if entity @s[tag=!map.shown] if score @s layer matches 1 run scoreboard players add @s map.uses 1
execute if score @s crouch matches 1 if score @s prev.crouch matches 0 if score @s time_since_crouch matches ..7 if score $var game.stage matches 1 if entity @s[tag=!map.shown] if score $var map.type matches 0 if score @s layer matches 1 run function map:type/set/maze
execute if score @s crouch matches 1 if score @s prev.crouch matches 0 if score @s time_since_crouch matches ..7 if score $var game.stage matches 1 if entity @s[tag=!map.shown] if score $var map.type matches 1 if score @s layer matches 1 run function map:type/set/eye_path
execute if score @s crouch matches 1 if score @s prev.crouch matches 0 if score @s time_since_crouch matches ..7 if score $var game.stage matches 1 if entity @s[tag=map.shown] run function map:type/clear

execute if score @s crouch matches 1 if score @s prev.crouch matches 0 run scoreboard players set @s time_since_crouch 0
execute if score @s crouch matches 1 if score @s prev.crouch matches 0 if score @s item.id matches 333 run function player:inv/choose_player

scoreboard players operation @s prev.crouch = @s crouch
scoreboard players set @s crouch 0
scoreboard players add @s time_since_crouch 1


scoreboard players enable @s help
scoreboard players enable @s social
scoreboard players enable @s items
scoreboard players enable @s music
scoreboard players enable @s debug
execute if score @s help matches 1.. run tellraw @s [{"text":"\n攻略链接:","color":"yellow"},{"text":"\n","color":"gray"},{"text":" \uE861 ","color":"white"},{"text":"Youtube\n","bold":true,"color":"red","clickEvent":{"action":"open_url","value":"https://www.youtube.com/@Urgle"}}]
execute if score @s help matches 1.. run scoreboard players set @s help 0
execute if score @s social matches 1.. run tellraw @s [{"text":"\nUrgle","color":"yellow"},{"text":" -","color":"gray"},{"text":" \uE861 ","color":"white"},{"text":"Youtube","bold":true,"color":"red","clickEvent":{"action":"open_url","value":"https://www.youtube.com/@Urgle"}},{"text":" | \uE860 ","color":"white"},{"text":"Discord","bold":true,"color":"dark_aqua","clickEvent":{"action":"open_url","value":"https://discord.gg/hTK5236VsR"}},{"text":" (在此游玩独家地图)","color":"dark_aqua"},{"text":"\n\n"},{"text":"Vandoorea","color":"white"},{"text":" -","color":"gray"},{"text":" \uE861 ","color":"white"},{"text":"Youtube","bold":true,"color":"red","clickEvent":{"action":"open_url","value":"https://www.youtube.com/@Vandoorea"}},{"text":"\n"},{"text":"Scott Buckley","color":"white"},{"text":" -","color":"gray"},{"text":" \uE861 ","color":"white"},{"text":"Youtube ","bold":true,"color":"red","clickEvent":{"action":"open_url","value":"https://www.youtube.com/@ScottBuckley"}},{"text":"|","color":"white"},{"text":" \uE862","color":"white"},{"text":" 网站","bold":true,"color":"white","clickEvent":{"action":"open_url","value":"https://scottbuckley.com.au/library"}},{"text":" (无版权音乐!)","color":"white"},{"text":"\nAandeel","color":"white"},{"text":" -","color":"gray"},{"text":" \uE862","color":"white"},{"text":" 网站","bold":true,"color":"white","clickEvent":{"action":"open_url","value":"https://aandeel.co.uk/"}},{"text":"","color":"white"},{"text":"\n\n"}]
execute if score @s social matches 1.. run scoreboard players set @s social 0
execute if score @s items matches 1.. run function player:give_items
execute if score @s items matches 1.. run scoreboard players set @s items 0
execute if score @s music matches 1.. run function player:music/get
execute if score @s music matches 1.. run scoreboard players set @s music 0
execute if score @s submachine_info matches 1.. run tellraw @s ["",{"text":"\n'Submachine' ","bold":true,"color":"gold"},{"text":" 该游戏是一个点击式解谜游戏,你可以在神秘且怪异的氛围中收集物品并解决谜题。\n\n简单来说,这个游戏就像AAA级的点击式游戏。\n\n作者（Mateuzs Skutnik）最近将所有这些游戏汇编成一款,视觉效果、音效和整体质量都有所提升。不过,你仍需要为这款游戏付费。","color":"white"},{"text":"(steam 链接)","color":"aqua","clickEvent":{"action":"open_url","value":"https://store.steampowered.com/app/1564790/Submachine_Legacy/"}},{"text":"\n\n原来的游戏仍然是免费的,但已经过时了(大多数游戏已经有10年或更长时间的历史了)。\n并且是Flash游戏,你需要flashpoint来运行它们。 "},{"text":"(链接)\n","color":"aqua","clickEvent":{"action":"open_url","value":"https://flashpointarchive.org/downloads/"}}]
execute if score @s submachine_info matches 1.. run scoreboard players set @s submachine_info 0
execute if score @s debug matches 1.. run function debug:trigger/run
execute if score @s debug matches 1.. run scoreboard players set @s debug 0
